#include "stdafx.h"

#ifndef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN
#endif
#include <stdio.h>
#include <stdarg.h>
#include <windows.h>
#include "xdraw.h"
//
#if defined(__BORLANDC__)
	#pragma comment(lib,"dxguid_b.lib")
	#pragma comment(lib,"ddraw_b.lib")
#else
	#pragma comment(lib,"dxguid.lib")
	#pragma comment(lib,"ddraw.lib")
#endif
//
#define XRGB(r,g,b) ((r<<16)|(g<<8)|(b))
//
static LPDIRECTDRAW7           g_pDD         = NULL;	// DirectDraw object
static LPDIRECTDRAWSURFACE7    g_pDDSPrimary = NULL;   // DirectDraw primary surface
static LPDIRECTDRAWSURFACE7    g_pDDSBack    = NULL;   // DirectDraw back surface
static LPDIRECTDRAWSURFACE7    g_pSprite[MAX_SPRITE_SURFACE]	={ NULL};   // DirectDraw back surface
static LPDIRECTDRAWSURFACE7    g_pBGSurface		=NULL;   // DirectDraw back surface
static LPDIRECTDRAWSURFACE7    g_pBG			=NULL;   // DirectDraw back surface
static BOOL                    g_bActive     = TRUE;  // App is running/active
static BOOL                    g_bReady      = FALSE;  // App is ready for updates
static BOOL                    g_bWindowed   = TRUE;   // App is in windowed mode
static RECT                    g_rcWindow;             // Saves the window size & pos.
static RECT                    g_rcViewport;           // Pos. & size to blt from
static RECT                    g_rcScreen;             // Screen pos. for blt
//

static int DisplayWidth=DefaultDisplayWidth,DisplayHeight=DefaultDisplayHeight;
static int DisplayColor=DefaultDisplayColor;
static int SpriteMaxPage=DefaultSpriteMaxPage;
//
//static int DisplayWidth,DisplayHeight;
//static int DisplayColor,SpriteMaxPage;
static XDraw::SPRITE_PATTERN SpritePa[MAX_SPRITE]={0};
static XDraw::SPRITE_ATRIB SpriteAt[MAX_SPRITE]={0};


static HBITMAP SpriteSurfaceBmp[MAX_SPRITE_SURFACE]={NULL};//XvCgp^[
static HBITMAP BGSurfaceBmp=NULL;//BGp^[
static HBITMAP BGBmp=NULL;//ۑp
static HBITMAP TempBmp=NULL;//ꎞIgp
static LPVOID pSpriteSurface[MAX_SPRITE_SURFACE]={NULL};//XvCgp^[
static LPVOID pBGSurface=NULL;//BGp^[
static LPVOID pBG=NULL;//ۑp
static LPVOID pTemp=NULL;//ꎞIgp
static unsigned int  SpriteColor[MAX_SPRITE_SURFACE]={0};//F

static HWND XDraw_hWnd=NULL;
static int XDraw_Use_Flag=0;//ĂƂP
static int ChangeScreenFlag=0;
//-------------------------------------------------------

LPVOID XDraw::GetBGDispDIB(){return pBG;}
LPVOID XDraw::GetBGSurfaceDIB(){return pBGSurface;}
LPVOID XDraw::GetSpriteDIB(int page){return pSpriteSurface[page%MAX_SPRITE];}

//-----------------------------------------------------------------------------
// Name: DDCopyBitmap()
// Desc: Draw a bitmap into a DirectDrawSurface
//-----------------------------------------------------------------------------
static HRESULT
DDCopyBitmap(IDirectDrawSurface7 * pdds, HBITMAP hbm, int x, int y,
             int dx, int dy)
{
    HDC                     hdcImage;
    HDC                     hdc;
    BITMAP                  bm;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hr;

    if (hbm == NULL || pdds == NULL)
        return E_FAIL;
    //
    // Make sure this surface is restored.
    //
    pdds->Restore();
    //
    // Select bitmap into a memoryDC so we can use it.
    //
    hdcImage = CreateCompatibleDC(NULL);
    if (!hdcImage)
        OutputDebugString("createcompatible dc failed\n");
    SelectObject(hdcImage, hbm);
    //
    // Get size of the bitmap
    //
    GetObject(hbm, sizeof(bm), &bm);
    dx = dx == 0 ? bm.bmWidth : dx;     // Use the passed size, unless zero
    dy = dy == 0 ? bm.bmHeight : dy;
    //
    // Get size of surface.
    //
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_HEIGHT | DDSD_WIDTH;
    pdds->GetSurfaceDesc(&ddsd);

    if ((hr = pdds->GetDC(&hdc)) == DD_OK)
    {
        StretchBlt(hdc, 0, 0, ddsd.dwWidth, ddsd.dwHeight, hdcImage, x, y,
                   dx, dy, SRCCOPY);
        pdds->ReleaseDC(hdc);
    }
    DeleteDC(hdcImage);
    return hr;
}


static IDirectDrawSurface7 *
DDLoadBitmap(IDirectDraw7 * pdd, LPCSTR szBitmap, int dx, int dy)
{
    HBITMAP                 hbm;
    BITMAP                  bm;
    DDSURFACEDESC2          ddsd;
    IDirectDrawSurface7    *pdds;

    //
    //  Try to load the bitmap as a resource, if that fails, try it as a file
    //
    hbm = (HBITMAP) LoadImage(GetModuleHandle(NULL), szBitmap, IMAGE_BITMAP, dx,
                              dy, LR_CREATEDIBSECTION);
    if (hbm == NULL)
        hbm = (HBITMAP) LoadImage(NULL, szBitmap, IMAGE_BITMAP, dx, dy,
                                  LR_LOADFROMFILE | LR_CREATEDIBSECTION);
    if (hbm == NULL)
        return NULL;
    //
    // Get size of the bitmap
    //
    GetObject(hbm, sizeof(bm), &bm);
    //
    // Create a DirectDrawSurface for this bitmap
    //
    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
    ddsd.dwWidth = bm.bmWidth;
    ddsd.dwHeight = bm.bmHeight;
    if (pdd->CreateSurface(&ddsd, &pdds, NULL) != DD_OK)
        return NULL;
    DDCopyBitmap(pdds, hbm, 0, 0, 0, 0);
    DeleteObject(hbm);
    return pdds;
}



//-----------------------------------------------------------------------------
// Name: DDReLoadBitmap()
// Desc: Load a bitmap from a file or resource into a directdraw surface.
//       normaly used to re-load a surface after a restore.
//-----------------------------------------------------------------------------
static
DDReLoadBitmap(IDirectDrawSurface7 * pdds, LPCSTR szBitmap)
{
    HBITMAP                 hbm;
    HRESULT                 hr;

    //
    //  Try to load the bitmap as a resource, if that fails, try it as a file
    //
    hbm = (HBITMAP) LoadImage(GetModuleHandle(NULL), szBitmap, IMAGE_BITMAP, 0,
                              0, LR_CREATEDIBSECTION);
    if (hbm == NULL)
        hbm = (HBITMAP) LoadImage(NULL, szBitmap, IMAGE_BITMAP, 0, 0,
                                  LR_LOADFROMFILE | LR_CREATEDIBSECTION);
    if (hbm == NULL)
    {
        OutputDebugString("handle is null\n");
        return E_FAIL;
    }
    hr = DDCopyBitmap(pdds, hbm, 0, 0, 0, 0);
    if (hr != DD_OK)
    {
        OutputDebugString("ddcopybitmap failed\n");
    }
    DeleteObject(hbm);
    return hr;
}


//-----------------------------------------------------------------------------
// Name: DDLoadPalette()
// Desc: Create a DirectDraw palette object from a bitmap resource
//       if the resource does not exist or NULL is passed create a
//       default 332 palette.
//-----------------------------------------------------------------------------
static IDirectDrawPalette *
DDLoadPalette(IDirectDraw7 * pdd, LPCSTR szBitmap)
{
    IDirectDrawPalette     *ddpal;
    int                     i;
    int                     n;
    int                     fh;
    HRSRC                   h;
    LPBITMAPINFOHEADER      lpbi;
    PALETTEENTRY            ape[256];
    RGBQUAD                *prgb;

    //
    // Build a 332 palette as the default.
    //
    for (i = 0; i < 256; i++)
    {
        ape[i].peRed = (BYTE) (((i >> 5) & 0x07) * 255 / 7);
        ape[i].peGreen = (BYTE) (((i >> 2) & 0x07) * 255 / 7);
        ape[i].peBlue = (BYTE) (((i >> 0) & 0x03) * 255 / 3);
        ape[i].peFlags = (BYTE) 0;
    }
    //
    // Get a pointer to the bitmap resource.
    //
    if (szBitmap && (h = FindResource(NULL, szBitmap, RT_BITMAP)))
    {
        lpbi = (LPBITMAPINFOHEADER) LockResource(LoadResource(NULL, h));
        if (!lpbi)
            OutputDebugString("lock resource failed\n");
        prgb = (RGBQUAD *) ((BYTE *) lpbi + lpbi->biSize);
        if (lpbi == NULL || lpbi->biSize < sizeof(BITMAPINFOHEADER))
            n = 0;
        else if (lpbi->biBitCount > 8)
            n = 0;
        else if (lpbi->biClrUsed == 0)
            n = 1 << lpbi->biBitCount;
        else
            n = lpbi->biClrUsed;
        //
        //  A DIB color table has its colors stored BGR not RGB
        //  so flip them around.
        //
        for (i = 0; i < n; i++)
        {
            ape[i].peRed = prgb[i].rgbRed;
            ape[i].peGreen = prgb[i].rgbGreen;
            ape[i].peBlue = prgb[i].rgbBlue;
            ape[i].peFlags = 0;
        }
    }
    else if (szBitmap && (fh = _lopen(szBitmap, OF_READ)) != -1)
    {
        BITMAPFILEHEADER        bf;
        BITMAPINFOHEADER        bi;

        _lread(fh, &bf, sizeof(bf));
        _lread(fh, &bi, sizeof(bi));
        _lread(fh, ape, sizeof(ape));
        _lclose(fh);
        if (bi.biSize != sizeof(BITMAPINFOHEADER))
            n = 0;
        else if (bi.biBitCount > 8)
            n = 0;
        else if (bi.biClrUsed == 0)
            n = 1 << bi.biBitCount;
        else
            n = bi.biClrUsed;
        //
        //  A DIB color table has its colors stored BGR not RGB
        //  so flip them around.
        //
        for (i = 0; i < n; i++)
        {
            BYTE        r = ape[i].peRed;

            ape[i].peRed = ape[i].peBlue;
            ape[i].peBlue = r;
        }
    }
    pdd->CreatePalette(DDPCAPS_8BIT, ape, &ddpal, NULL);
    return ddpal;
}
/*
DWORD XSprite::DIB2DD_ColorMatch(LPDIRECTDRAWSURFACE3 pdds, COLORREF rgb)
{
    COLORREF rgbT;
    HDC hdc;
    DWORD dw = CLR_INVALID;
    DDSURFACEDESC ddsd;
    HRESULT hres;

    //
    //  use GDI SetPixel to color match for us
    //
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
	rgbT = GetPixel(hdc, 0, 0);             // save current pixel value
	SetPixel(hdc, 0, 0, rgb);               // set our value
	pdds->ReleaseDC(hdc);
    }

    //
    // now lock the surface so we can read back the converted color
    //
    ddsd.dwSize = sizeof(ddsd);
    while ((hres = pdds->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
	;

    if (hres == DD_OK)
    {
	dw  = *(DWORD *)ddsd.lpSurface;                     // get DWORD
        if(ddsd.ddpfPixelFormat.dwRGBBitCount < 32)
            dw &= (1 << ddsd.ddpfPixelFormat.dwRGBBitCount)-1;  // mask it to bpp
	pdds->Unlock(NULL);
    }

    //
    //  now put the color that was there back.
    //
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
	SetPixel(hdc, 0, 0, rgbT);
	pdds->ReleaseDC(hdc);
    }

    return dw;
}*/
static DWORD
DDColorMatch(IDirectDrawSurface7 * pdds, COLORREF rgb)
{
    COLORREF                rgbT;
    HDC                     hdc;
    DWORD                   dw = CLR_INVALID;
    DDSURFACEDESC2          ddsd;
    HRESULT                 hres;

    //
    //  Use GDI SetPixel to color match for us
    //
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        rgbT = GetPixel(hdc, 0, 0);     // Save current pixel value
        SetPixel(hdc, 0, 0, rgb);       // Set our value
        pdds->ReleaseDC(hdc);
    }
    //
    // Now lock the surface so we can read back the converted color
    //
    ddsd.dwSize = sizeof(ddsd);
    while ((hres = pdds->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
        ;
    if (hres == DD_OK)
    {
        dw = *(DWORD *) ddsd.lpSurface;                 // Get DWORD
        if (ddsd.ddpfPixelFormat.dwRGBBitCount < 32)
            dw &= (1 << ddsd.ddpfPixelFormat.dwRGBBitCount) - 1;  // Mask it to bpp
        pdds->Unlock(NULL);
    }
    //
    //  Now put the color that was there back.
    //
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        SetPixel(hdc, 0, 0, rgbT);
        pdds->ReleaseDC(hdc);
    }
    return dw;
}




//-----------------------------------------------------------------------------
// Name: DDSetColorKey()
// Desc: Set a color key for a surface, given a RGB.
//       If you pass CLR_INVALID as the color key, the pixel
//       in the upper-left corner will be used.
//-----------------------------------------------------------------------------
static HRESULT
DDSetColorKey(IDirectDrawSurface7 * pdds, COLORREF rgb)
{
    DDCOLORKEY              ddck;

    ddck.dwColorSpaceHighValue = DDColorMatch(pdds, rgb);
    ddck.dwColorSpaceLowValue = ddck.dwColorSpaceHighValue;
    return pdds->SetColorKey(DDCKEY_SRCBLT, &ddck);
}

//


void XDraw::SetActiveFlag(int f)
{
	g_bActive=f;
}
void XDraw::SetReadyFlag(int f)
{
	g_bReady=f;
}
int XDraw::GetActiveFlag()
{
	return g_bActive;
}
int XDraw::GetReadyFlag()
{
	return g_bReady;
}
//
void XDraw::SetScreen(int Width,int Height,int Color,int SpritePage)
{
	if(DisplayWidth==Width && DisplayHeight==Height && DisplayColor==Color && SpriteMaxPage==SpritePage)
		return;
	DisplayWidth=Width;
	DisplayHeight=Height;
	DisplayColor=Color;
	SpriteMaxPage=SpritePage;
//	if(XDraw_hWnd==NULL)
//		return;
//	delete[] SpritePa;
//	delete[] SpriteAt;
	int r=InitXDraw(NULL,SpriteMaxPage);
	if(r==FALSE){
		MessageBox(XDraw_hWnd,"DirectDrawł܂B","x",MB_OK);
		exit(0);
	}
}
void XDraw::SetHWND(HWND hwnd)
{
	if(InstantFlag){
		InstantFlag=0;
		XDraw_hWnd=hwnd;
		GetWindowRect(hwnd, &g_rcWindow);
		SetScreen(DefaultDisplayWidth,DefaultDisplayHeight,DefaultDisplayColor,1);
	}
}
#define XDRAW_INIT() \
{\
	ShowBenchFlag=0;\
	FontType=0;\
	PenSize(1);\
	UseSpriteFlag=1;\
	AlphaDepth=256;AlphaColor=0;\
}
XDraw::XDraw(){
//		XDraw_Use_Flag=0;
	InstantFlag=1;//Ƀ\[XJȂ
//	DisplayWidth=DefaultDisplayWidth,DisplayHeight=DefaultDisplayHeight;
//	DisplayColor=DefaultDisplayColor,SpriteMaxPage=DefaultSpriteMaxPage;
//	SPRITE_PATTERN *SpritePa=new SPRITE_PATTERN[MAX_SPRITE];//[MAX_SPRITE];
//	SPRITE_ATRIB *SpriteAt=new SPRITE_ATRIB[MAX_SPRITE];//[MAX_SPRITE];
	XDRAW_INIT();
}

XDraw::XDraw(HWND hwnd)
{
//		XDraw_Use_Flag=0;
	InstantFlag=0;
	XDRAW_INIT();
	XDraw_hWnd=hwnd;
	GetWindowRect(hwnd, &g_rcWindow);
	DisplayWidth=DefaultDisplayWidth;
	DisplayHeight=DefaultDisplayHeight;
	DisplayColor=DefaultDisplayColor;
	strcpy(FontName[0],"lr ");
	strcpy(FontName[1],"lr SVbN");
	strcpy(FontName[2],"MS UI Gothic");
	strcpy(FontName[3],"Arial Black");//"Wingdings");
	InitXDraw(NULL,SpriteMaxPage);
//	SPRITE_PATTERN *SpritePa=new SPRITE_PATTERN[MAX_SPRITE];//[MAX_SPRITE];
//	SPRITE_ATRIB *SpriteAt=new SPRITE_ATRIB[MAX_SPRITE];//[MAX_SPRITE];
//	BGSurfaceBmp=NULL;
//	BGBmp=NULL;
//	for(int a=0;a<MAX_SPRITE_SURFACE;++a){
//		SpriteSurfaceBmp[a]=NULL;
//	}
}
XDraw::~XDraw()
{
	if(InstantFlag==0){
		QuitXDraw();
		ReleaseAllObjects(XDraw_hWnd);
		if(BGSurfaceBmp)
			DeleteObject(BGSurfaceBmp);
		if(BGBmp)
			DeleteObject(BGBmp);
		if(TempBmp)
			DeleteObject(TempBmp);
		for(int a=0;a<MAX_SPRITE_SURFACE;++a){
			if(SpriteSurfaceBmp[a])
				DeleteObject(SpriteSurfaceBmp[a]);
		}
	}

//	ReleaseAllObjects(XDraw_hWnd);
}
HWND XDraw::GetDrawHWND(){
	return XDraw_hWnd;
}
HBITMAP XDraw::CreateCompatibleDIBBitmap(int x,int y,int color,LPVOID *dib)
{
	//LPVOID lpDIB;
	int z=sizeof(HBITMAP);
	HBITMAP hBufferBmp=NULL;

		BITMAPINFO bmpinfo;
		bmpinfo.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
		bmpinfo.bmiHeader.biWidth=x;
		bmpinfo.bmiHeader.biHeight=-y;//̐Ȃgbv_Echa
		bmpinfo.bmiHeader.biPlanes=1;
		bmpinfo.bmiHeader.biBitCount=color;//J[
		if(color>=16)
			bmpinfo.bmiHeader.biCompression=BI_RGB;
		else
			bmpinfo.bmiHeader.biCompression=BI_RGB;//BI_RLE8;

		bmpinfo.bmiHeader.biSizeImage=0;
		bmpinfo.bmiHeader.biXPelsPerMeter=0;
		bmpinfo.bmiHeader.biYPelsPerMeter=0;
		bmpinfo.bmiHeader.biClrUsed=0;
		bmpinfo.bmiHeader.biClrImportant=256;

		LPVOID pDIB;
		HDC hDC=GetDC(NULL);
		if(color>=16){
			hBufferBmp = CreateDIBSection(hDC, &bmpinfo, DIB_RGB_COLORS, &pDIB, NULL, NULL);
		}else{
			hBufferBmp = CreateDIBSection(hDC, &bmpinfo, DIB_PAL_COLORS, &pDIB, NULL, NULL);
		}
		ReleaseDC(NULL,hDC);
		if(dib)
			*dib=(LPSTR)pDIB;
		{
			HDC dc=GetDC(NULL);
			HDC hMemDC=CreateCompatibleDC(dc);
			HBITMAP hold=(HBITMAP)SelectObject(hMemDC,hBufferBmp);

				HBRUSH hbr=CreateSolidBrush(0);
				RECT r;
				r.left=0;
				r.top=0;
				r.right=x;//+1;//2002-3-25ύX
				r.bottom=y;//+1;//2002-3-25ύX
				FillRect(hMemDC,&r,hbr);
				DeleteObject(hbr);
			SelectObject(hMemDC,hold);
			ReleaseDC(NULL,dc);
		}
		//*lpDIB=pDIB;

	return(hBufferBmp);
}
int XDraw::InitXDraw(HWND hwnd,int maxpage)
{
	static int DisplayWidth_Keep=0,DisplayHeight_Keep=0,SpriteMaxPage_Keep=0;
	if(hwnd){
		XDraw_hWnd=hwnd;
		GetWindowRect(hwnd, &g_rcWindow);
	}
	if(XDraw_hWnd==NULL)
		return FALSE;
	if(maxpage>=MAX_SPRITE_SURFACE)
		maxpage=MAX_SPRITE_SURFACE;
	InstantFlag=0;
	SpriteMaxPage=maxpage;

    HRESULT         hRet;
    hRet = DirectDrawCreateEx(NULL, (VOID**)&g_pDD, IID_IDirectDraw7, NULL);
    if (FAILED(hRet))
        return InitFail(XDraw_hWnd, hRet, "DirectDrawCreateEx FAILED");

    // Initialize all the surfaces we need
	int a;
//	LPVOID BackDIB,BGDispDIB,BGSurfaceDIB;
//	LPVOID SpriteDIB[MAX_SPRITE_SURFACE],MaskDIB[MAX_SPRITE_SURFACE];//ڎgp֎~
//	HBITMAP SpriteSurfaceBmp[MAX_SPRITE_SURFACE];//XvCgp^[
//	HBITMAP BGSurfaceBmp;//BGp^[
//	HBITMAP BGBmp;//ۑp
//	char* dummy;
	if(DisplayHeight!=DisplayHeight_Keep || DisplayWidth!=DisplayWidth_Keep || SpriteMaxPage_Keep!=SpriteMaxPage){
		if(BGSurfaceBmp)
			DeleteObject(BGSurfaceBmp);
		BGSurfaceBmp=CreateCompatibleDIBBitmap(DisplayWidth,DisplayHeight,24,&pBGSurface);
		if(BGBmp)
			DeleteObject(BGBmp);
		BGBmp=CreateCompatibleDIBBitmap(DisplayWidth,DisplayHeight,24,&pBG);
		if(TempBmp)
			DeleteObject(TempBmp);
		TempBmp=CreateCompatibleDIBBitmap(DisplayWidth,DisplayHeight,DisplayColor,&pTemp);
		for(int a=0;a<maxpage;++a){
			if(SpriteSurfaceBmp[a])
				DeleteObject(SpriteSurfaceBmp[a]);
			SpriteSurfaceBmp[a]=CreateCompatibleDIBBitmap(DisplayWidth,DisplayHeight,24,&pSpriteSurface[a]);
		}
	}
	for(a=0;a<MAX_SPRITE_SURFACE/*maxpage*/;++a){
	//	if(SpriteSurfaceBmp[a])
	//		DeleteObject(SpriteSurfaceBmp[a]);
	//	SpriteSurfaceBmp[a]=CreateCompatibleDIBBitmap(DisplayWidth,DisplayHeight,24,&dummy);
		SpriteColor[a]=RGB(255,0,255);
	}
    hRet = InitSurfaces(XDraw_hWnd,maxpage);
    if (FAILED(hRet))
    	return FALSE;

    g_bReady = TRUE;
	DisplayWidth_Keep=DisplayWidth,DisplayHeight_Keep=DisplayHeight;
	SpriteMaxPage_Keep=SpriteMaxPage;
	return TRUE;
}

//-----------------------------------------------------------------------------
// Name: ReleaseAllObjects()
// Desc: Release all DDraw objects we use
//-----------------------------------------------------------------------------
HRESULT XDraw::ReleaseAllObjects(HWND hWnd)
{
	if(XDraw_Use_Flag==0)
		return DD_OK;
	XDraw_Use_Flag=0;
    if (g_pDD != NULL)
    {
        g_pDD->SetCooperativeLevel(hWnd, DDSCL_NORMAL);
		for(int a=SpriteMaxPage-1;a>=0;--a){
			if (g_pSprite[a] != NULL)
			{
			    g_pSprite[a]->Release();
			    g_pSprite[a] = NULL;
			}
		}
		if (g_pBG != NULL)
        {
            g_pBG->Release();
            g_pBG = NULL;
        }
		if (g_pBGSurface != NULL)
        {
            g_pBGSurface->Release();
            g_pBGSurface = NULL;
        }
		if (g_pDDSBack != NULL)
        {
            g_pDDSBack->Release();
            g_pDDSBack = NULL;
        }
        if (g_pDDSPrimary != NULL)
        {
            g_pDDSPrimary->Release();
            g_pDDSPrimary = NULL;
        }
    }
    return DD_OK;
}




//-----------------------------------------------------------------------------
// Name: InitFail()
// Desc: This function is called if an initialization function fails
//-----------------------------------------------------------------------------
HRESULT XDraw::InitFail(HWND hWnd, HRESULT hRet, LPCTSTR szError, ...)
{
    char            szBuff[128];
    va_list         vl;

    va_start(vl, szError);
    vsprintf(szBuff, szError, vl);
    ReleaseAllObjects(hWnd);
    MessageBox(hWnd, szBuff, "XDRAWNX", MB_OK);
    DestroyWindow(hWnd);
    va_end(vl);
    return hRet;
}




//-----------------------------------------------------------------------------
// Name: UpdateFrame()
// Desc: Blts and moves a bouncing ball, as well as displays helpful text
//-----------------------------------------------------------------------------
static int Bench()
{
	static int time1=0,time2=0;
	static int count=0,count2=0;
	time1=GetTickCount();
	++count2;
	if(time1>(time2+1000)){
		time2=time1;
		count=count2;
		count2=0;
	}
	return count;
}
/*
BOOL XDraw::UpdateFrame(HWND hWnd)
{
	static int time1=0,time2=0,count=0,count2=0;
	time1=GetTickCount();
	if(time1>(time2+1000)){
		count2=count;
		time2=time1;
		count=0;
	}
	++count;
    DDBLTFX     ddbltfx;
    HDC         hDC;
    static int  x1 = 0,
                y1 = 0,
                x2 = 40,
                y2 = 40;
    HBRUSH      hOldBrush;
    HPEN        hOldPen;
    static int  xDir = +1,
                yDir = +1;

    // Use the blter to do a color fill to clear the back buffer
    ZeroMemory(&ddbltfx, sizeof(ddbltfx));
    ddbltfx.dwSize = sizeof(ddbltfx);
    ddbltfx.dwFillColor = RGB(0,0,255);
    g_pDDSBack->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);

    if (g_pDDSBack->GetDC(&hDC) == DD_OK)
    {
        // Paint the bouncing ball
        SetBkColor(hDC, RGB(0, 0, 255));
        SetTextColor(hDC, RGB(255, 255, 0));
        hOldBrush = (HBRUSH )SelectObject(hDC, GetStockObject(LTGRAY_BRUSH));
        hOldPen = (HPEN )SelectObject(hDC, GetStockObject(WHITE_PEN));
        Ellipse(hDC, x1, y1, x2, y2);
        SelectObject(hDC, hOldPen);
        SelectObject(hDC, hOldBrush);

		POINT point;
		HPEN hpen=CreatePen(PS_SOLID	, 1, RGB(255,0,0));
		HPEN hpenold=(HPEN)SelectObject(hDC,hpen);
		MoveToEx(hDC,0,0,&point);
		LineTo(hDC,639,479);
		MoveToEx(hDC,639,0,&point);
		LineTo(hDC,639,479);
		MoveToEx(hDC,0,0,&point);
		LineTo(hDC,0,479);
		MoveToEx(hDC,0,479,&point);
		LineTo(hDC,639,479);
		SelectObject(hDC,hpenold);
		DeleteObject(hpen);


        // Move the bouncing ball and make it bounce
        x1 += xDir;
        x2 += xDir;
        if (x1 < 0)
        {
            x1 = 0;
            x2 = 40;
            xDir = -xDir;
        }
        if (x2 >= 640)
        {
            x1 = 640 - 1 - 40;
            x2 = 640 - 1;
            xDir = -xDir;
        }
        y1 += yDir;
        y2 += yDir;
        if (y1 < 0)
        {
            y1 = 0;
            y2 = 40;
            yDir = -yDir;
        }
        if (y2 >= 480)
        {
            y1 = 480 - 1 - 40;
            y2 = 480 - 1;
            yDir = -yDir;
        }

        // Display the proper text
        TextOut(hDC, 0, 0, "Press Escape to quit", 20);
        if (g_bWindowed)
            TextOut(hDC, 0, 20, "Press Alt-Enter to switch to Full-Screen mode", 45);
        else
            TextOut(hDC, 0, 20, "Press Alt-Enter to switch to Windowed mode", 42);

		char moji[32];
		wsprintf(moji,"%04d[fps] %d ",Bench(),g_bActive);
        TextOut(hDC, 0, 40, moji, strlen(moji));
        g_pDDSBack->ReleaseDC(hDC);
    }
	
	RECT dr={0,0,320,240};
	RECT sr={0,0,320,240};
	static int xx=0;
	xx=(xx+1)&3;
	if (g_pSprite[0]->GetDC(&hDC) == DD_OK){
		char moji[256];
		wsprintf(moji,"%8d  ",count2);
         TextOut(hDC, 0, 20, moji,strlen(moji));
        g_pSprite[0]->ReleaseDC(hDC);
	}
	
	//	sr.right=640-xx;
	for(int i=0;i<21;++i){
		dr.left=i*4;
		dr.top=i*4;
		dr.right=dr.left+320;
		dr.bottom=dr.top+240;
		int p=i%10;
		//g_pDDSBack->Blt(&dr, g_pSprite[p],  &sr, DDBLT_WAIT | DDBLT_KEYSRC ,  NULL);
		g_pDDSBack->BltFast(dr.left,dr.top, g_pSprite[p],  &sr, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);// 
	}
    return TRUE;
}
*/
void XDraw::PutBGSurface(int x,int y,int w,int h,int pagemode)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	//wi
	RECT sr={0,0,640,480};

    // Use the blter to do a color fill to clear the back buffer
    DDBLTFX     ddbltfx;
    ZeroMemory(&ddbltfx, sizeof(ddbltfx));
    ddbltfx.dwSize = sizeof(ddbltfx);
	switch(pagemode){
		case -1:
		    ddbltfx.dwFillColor = 0x000000;//RGB(255,255,255);
			g_pDDSBack->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
		break;
		case 0:
			sr.right=x;
			sr.top=y;
			sr.right=x+w;
			sr.bottom=y+h;
		//	g_pDDSBack->BltFast(0,0, g_pBG,  &sr, DDBLTFAST_WAIT);// 
			g_pDDSBack->Blt(&sr, g_pBG,  &sr, DDBLT_WAIT ,  NULL);
			break;
	}
}

BOOL XDraw::UpdateFrame(HWND hWnd)
{
	PutBGSurface(0,0,DisplayWidth,DisplayHeight);

	int i;
	for(i=MAX_SPRITE-1;i>=0;--i){
		if(SpriteAt[i].w && SpriteAt[i].h){
			/*
			dr.left=SpriteAt[i].x;
			dr.top=SpriteAt[i].y;
			dr.right=SpriteAt[i].x+SpriteAt[i].w;
			dr.bottom=SpriteAt[i].y+SpriteAt[i].h;
			sr.left=SpriteAt[i].px;
			sr.top=SpriteAt[i].py;
			sr.right=SpriteAt[i].px+SpriteAt[i].w;
			sr.bottom=SpriteAt[i].py+SpriteAt[i].h;
			int page=SpriteAt[i].page;
			*/
			//g_pDDSBack->Blt(&dr, g_pSprite[p],  &sr, DDBLT_WAIT | DDBLT_KEYSRC ,  NULL);
			//g_pDDSBack->BltFast(dr.left,dr.top, g_pSprite[page],  &sr, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);// 
			PutSpriteChip(SpriteAt[i].x,SpriteAt[i].y,SpriteAt[i].w,SpriteAt[i].h,SpriteAt[i].px,SpriteAt[i].py,
				SpriteAt[i].page,SpriteAt[i].zoomx,SpriteAt[i].zoomy,SpriteAt[i].hflag);
		}
	}
	//Test();
	UpdateBuffer(g_pDDSBack);
    return TRUE;
}
void XDraw::BenchTask()
{
	static int time1=0,time2=0,count=0,count2=0;
	time1=GetTickCount();
	if(time1>(time2+1000)){
		count2=count;
		time2=time1;
		count=0;
	}
	++count;
	if(ShowBenchFlag){
//		HDC         hDC;
		//if (g_pDDSBack->GetDC(&hDC) == DD_OK)
		{
			char moji[32];
				HDC dc=GetWindowDC(XDraw_hWnd);
				wsprintf(moji,"%04d[fps]",Bench());
				if(IsWindow(XDraw_hWnd))
					TextOut(dc, DisplayWidth-120, 2, moji, strlen(moji));
				ReleaseDC(XDraw_hWnd,dc);
				
	//		wsprintf(moji,"%04d[fps] %d ",Bench(),g_bActive);
	  //      TextOut(hDC, 0, 0, moji, strlen(moji));
		//    g_pDDSBack->ReleaseDC(hDC);
		}
	}
}
void XDraw::Update()
{
	if(ChangeScreenFlag){
		ChangeScreenFlag=0;
        ChangeCoopLevel(XDraw_hWnd);
        g_bReady = TRUE;
	}
	//-------------------------------------------------------------
	//                    Idle processing
	//-------------------------------------------------------------
	// Update the background and flip every time the timer ticks
    if(GetActiveFlag()==0 || GetReadyFlag()==0)
		return;
	if(IsWindow(XDraw_hWnd)==0){
		throw 0;//XbhI邽߁BXbhgĂȂΊOĂB
		return;
	}
	HRESULT         hRet;
	if(UseSpriteFlag)//ÕXvCg邩Ȃ
		UpdateFrame(XDraw_hWnd);

	AlphaBlt();
	BenchTask();
//	page = !page;
	while (TRUE)
	{
		if (g_bWindowed)
		{//EBhE[h
			TaskMove();
			hRet = g_pDDSPrimary->Blt(&g_rcScreen, g_pDDSBack,
									  &g_rcViewport, DDBLT_WAIT,
									  NULL);
		}
		else
		{//tXN[[h
			hRet = g_pDDSPrimary->Flip( NULL, 0L );
		}
		if (hRet == DD_OK )
			break;
		if (hRet == DDERR_SURFACELOST )
		{
			hRet = g_pDDSPrimary->Restore();
			if (hRet != DD_OK )
				break;
		}
		if (hRet != DDERR_WASSTILLDRAWING )
			break;
	}
}





//-----------------------------------------------------------------------------
// Name: InitSurfaces()
// Desc: Create all the needed DDraw surfaces and set the coop level
//-----------------------------------------------------------------------------
//static 
HRESULT XDraw::InitSurfaces(HWND hWnd,int NewPage)
{
    HRESULT		        hRet;
    DDSURFACEDESC2      ddsd;
    DDSCAPS2            ddscaps;
    LPDIRECTDRAWCLIPPER pClipper;
    if (FAILED(hRet = ReleaseAllObjects(hWnd)))
        return InitFail(hWnd, hRet, "ReleaseAllObjects FAILED");
	if(IsWindow(XDraw_hWnd)==0)
		return FALSE;

	SpriteMaxPage=NewPage;
    if (g_bWindowed)
    {
        // Get normal windowed mode
        hRet = g_pDD->SetCooperativeLevel(hWnd, DDSCL_NORMAL);
        if (hRet != DD_OK)
            return InitFail(hWnd, hRet, "SetCooperativeLevel FAILED");

    	// Get the dimensions of the viewport and screen bounds
    	GetClientRect(hWnd, &g_rcViewport);
    	GetClientRect(hWnd, &g_rcScreen);
    	ClientToScreen(hWnd, (POINT*)&g_rcScreen.left);
    	ClientToScreen(hWnd, (POINT*)&g_rcScreen.right);

        // Create the primary surface
        ZeroMemory(&ddsd,sizeof(ddsd));
        ddsd.dwSize = sizeof(ddsd);
        ddsd.dwFlags = DDSD_CAPS;
        ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
        hRet = g_pDD->CreateSurface(&ddsd, &g_pDDSPrimary, NULL);
        if (hRet != DD_OK)
            return InitFail(hWnd, hRet, "CreateSurface FAILED");

        // Create a clipper object since this is for a Windowed render
        hRet = g_pDD->CreateClipper(0, &pClipper, NULL);
        if (hRet != DD_OK)
            return InitFail(hWnd, hRet, "CreateClipper FAILED");

        // Associate the clipper with the window
        pClipper->SetHWnd(0, hWnd);
        g_pDDSPrimary->SetClipper(pClipper);
        pClipper->Release();
        pClipper = NULL;
		// Get the backbuffer. For fullscreen mode, the backbuffer was created
		// along with the primary, but windowed mode still needs to create one.
        ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags        = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
        ddsd.dwWidth        = DisplayWidth;
        ddsd.dwHeight       = DisplayHeight;
        ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;// | DDSCAPS_SYSTEMMEMORY ;
        hRet = g_pDD->CreateSurface(&ddsd, &g_pDDSBack, NULL);
        if (hRet != DD_OK)
            return InitFail(hWnd, hRet, "CreateSurface2 FAILED");

		{
			ZeroMemory(&ddsd, sizeof(ddsd));
		    ddsd.dwSize = sizeof(ddsd);
			ddsd.dwFlags        = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
			ddsd.dwWidth        = DisplayWidth;
			ddsd.dwHeight       = DisplayHeight;
			ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
			//BGSurface
			hRet = g_pDD->CreateSurface(&ddsd, &g_pBGSurface, NULL);
			if (hRet != DD_OK)
				return InitFail(hWnd, hRet, "BG-CreateSurface FAILED");
			//̓rbg}bv̏
			if(BGSurfaceBmp){
				SetupBitmapToSurface(BGSurfaceBmp,DRAW_BG_SURFACE);
			}else{
			   DDBLTFX     ddbltfx;
				ZeroMemory(&ddbltfx, sizeof(ddbltfx));
				ddbltfx.dwSize = sizeof(ddbltfx);
				ddbltfx.dwFillColor = RGB(0,0,0);
				g_pBGSurface->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
			}
			//BG
			hRet = g_pDD->CreateSurface(&ddsd, &g_pBG, NULL);
			if (hRet != DD_OK)
				return InitFail(hWnd, hRet, "BG-CreateSurface FAILED");
			//̓rbg}bv̏
			if(BGBmp){
				SetupBitmapToSurface(BGBmp,DRAW_BG);
			}else{
			   DDBLTFX     ddbltfx;
				ZeroMemory(&ddbltfx, sizeof(ddbltfx));
				ddbltfx.dwSize = sizeof(ddbltfx);
				ddbltfx.dwFillColor = RGB(0,0,0);
				g_pBG->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
			}
			/*
			DDBLTFX     ddbltfx;
			ZeroMemory(&ddbltfx, sizeof(ddbltfx));
			ddbltfx.dwSize = sizeof(ddbltfx);
			ddbltfx.dwFillColor = RGB(0,0,0);
			g_pBGSurface->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
			g_pBG->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
			*/
		}
		for(int a=0;a<SpriteMaxPage;++a){//T[tFX
			ZeroMemory(&ddsd, sizeof(ddsd));
		    ddsd.dwSize = sizeof(ddsd);
			ddsd.dwFlags        = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
			ddsd.dwWidth        = DisplayWidth;
			ddsd.dwHeight       = DisplayHeight;
			ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
			hRet = g_pDD->CreateSurface(&ddsd, &g_pSprite[a], NULL);
			if (hRet != DD_OK)
				return InitFail(hWnd, hRet, "Sprite-CreateSurface FAILED");
//			int cnum=DDColorMatch(g_pSprite,RGB(255,255,255));
				// J[EL[ݒ肷
			DDCOLORKEY ddckey;
			ddckey.dwColorSpaceLowValue = DDColorMatch(g_pSprite[a], SpriteColor[a] );
			ddckey.dwColorSpaceHighValue = DDColorMatch(g_pSprite[a], SpriteColor[a] );
			g_pSprite[a]->SetColorKey(DDCKEY_SRCBLT,&ddckey);
			//̓rbg}bv̏
			if(SpriteSurfaceBmp[a]){
				SetupBitmapToSurface(SpriteSurfaceBmp[a],a);
			}else{
			   DDBLTFX     ddbltfx;
				ZeroMemory(&ddbltfx, sizeof(ddbltfx));
				ddbltfx.dwSize = sizeof(ddbltfx);
				ddbltfx.dwFillColor = RGB(0,0,0);
				g_pSprite[a]->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
			}
		}
    }
    else
    {
    	// Get the dimensions of the viewport and screen bounds
    	// Store the rectangle which contains the renderer
    	SetRect(&g_rcViewport, 0, 0, DisplayWidth, DisplayHeight );
    	memcpy(&g_rcScreen, &g_rcViewport, sizeof(RECT) );
        // Get exclusive mode
        hRet = g_pDD->SetCooperativeLevel(hWnd, DDSCL_EXCLUSIVE |
                                                DDSCL_FULLSCREEN);
        if (hRet != DD_OK)
            return InitFail(hWnd, hRet, "SetCooperativeLevel FAILED(FULL)");

        // Set the video mode 
        hRet = g_pDD->SetDisplayMode( DisplayWidth, DisplayHeight, DisplayColor, 0, 0);
        if (hRet != DD_OK){
			for(;;){
				OutputDebugString("G[̂ŋIɉʃ[hς܂B\n");
				//MessageBox(hWnd,"ʃ[hG[","ERROR",MB_OK);
				if(DisplayColor==32){
					OutputDebugString("24bit!\n");
					hRet = g_pDD->SetDisplayMode( DisplayWidth, DisplayHeight, 24, 0, 0);
					DisplayColor=24;
					if (hRet == DD_OK)
						break;
				//	MessageBox(hWnd,"24bit!s","ERROR",MB_OK);
					OutputDebugString("24bit!s\n");
				}else{
					if(DisplayColor==24){
						OutputDebugString("32bit!\n");
						hRet = g_pDD->SetDisplayMode( DisplayWidth, DisplayHeight, 32, 0, 0);
						DisplayColor=32;
						if (hRet == DD_OK)
							break;
						OutputDebugString("32bit!s\n");
				//		MessageBox(hWnd,"32bit!s","ERROR",MB_OK);
					}
				}
				OutputDebugString("16bit!\n");
				hRet = g_pDD->SetDisplayMode( DisplayWidth, DisplayHeight, 16, 0, 0);
				DisplayColor=16;
				if (hRet != DD_OK){
				//	MessageBox(hWnd,"16bit!s","ERROR",MB_OK);
					OutputDebugString("16bit!s\n");
					OutputDebugString("̃VXełDirectXg܂B\n");
					return InitFail(hWnd, hRet, "SetDisplayMode FAILED(FULL)");
				}
				break;
			}
		}

        // Create the primary surface with 1 back buffer
        ZeroMemory(&ddsd,sizeof(ddsd));
        ddsd.dwSize = sizeof(ddsd);
        ddsd.dwFlags = DDSD_CAPS |
								DDSD_BACKBUFFERCOUNT;
        ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
                			  DDSCAPS_FLIP |
                			  DDSCAPS_COMPLEX;
        ddsd.dwBackBufferCount = 1;
        hRet = g_pDD->CreateSurface( &ddsd, &g_pDDSPrimary, NULL);
        if (hRet != DD_OK)
            return InitFail(hWnd, hRet, "CreateSurface FAILED(FULL)");


		// Get the backbuffer. For fullscreen mode, the backbuffer was created
		// along with the primary, but windowed mode still needs to create one.
		ZeroMemory(&ddscaps, sizeof(ddscaps));
        ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
        hRet = g_pDDSPrimary->GetAttachedSurface(&ddscaps, &g_pDDSBack);
        if (hRet != DD_OK)
            return InitFail(hWnd, hRet, "GetAttachedSurface FAILED");
		{
			ZeroMemory(&ddsd, sizeof(ddsd));
		    ddsd.dwSize = sizeof(ddsd);
			ddsd.dwFlags        = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
			ddsd.dwWidth        = DisplayWidth;
			ddsd.dwHeight       = DisplayHeight;
			ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
			//BGSurface
			hRet = g_pDD->CreateSurface(&ddsd, &g_pBGSurface, NULL);
			if (hRet != DD_OK)
				return InitFail(hWnd, hRet, "BG-CreateSurface FAILED");
			//̓rbg}bv̏
			if(BGSurfaceBmp){
				SetupBitmapToSurface(BGSurfaceBmp,DRAW_BG_SURFACE);
			}else{
			   DDBLTFX     ddbltfx;
				ZeroMemory(&ddbltfx, sizeof(ddbltfx));
				ddbltfx.dwSize = sizeof(ddbltfx);
				ddbltfx.dwFillColor = RGB(0,0,0);
				g_pBGSurface->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
			}
			//BG
			hRet = g_pDD->CreateSurface(&ddsd, &g_pBG, NULL);
			if (hRet != DD_OK)
				return InitFail(hWnd, hRet, "BG-CreateSurface FAILED");
			//̓rbg}bv̏
			if(BGBmp){
				SetupBitmapToSurface(BGBmp,DRAW_BG);
			}else{
			   DDBLTFX     ddbltfx;
				ZeroMemory(&ddbltfx, sizeof(ddbltfx));
				ddbltfx.dwSize = sizeof(ddbltfx);
				ddbltfx.dwFillColor = RGB(0,0,0);
				g_pBG->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
			}
			/*
			DDBLTFX     ddbltfx;
			ZeroMemory(&ddbltfx, sizeof(ddbltfx));
			ddbltfx.dwSize = sizeof(ddbltfx);
			ddbltfx.dwFillColor = RGB(0,0,0);
			g_pBGSurface->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
			g_pBG->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
			*/
		}
		for(int a=0;a<SpriteMaxPage;++a){//T[tFX
			 ZeroMemory(&ddsd,sizeof(ddsd));
		    ddsd.dwSize = sizeof(ddsd);
			ddsd.dwFlags        = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
			ddsd.dwWidth        = DisplayWidth;
			ddsd.dwHeight       = DisplayHeight;
			ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
			hRet = g_pDD->CreateSurface(&ddsd, &g_pSprite[a], NULL);
			if (hRet != DD_OK){
				return InitFail(hWnd, hRet, "Sprite-CreateSurface FAILED(FULL)");
			}
			//	DDCOLORKEY ddckey;
			//	ddckey.dwColorSpaceLowValue = DDColorMatch(g_pSprite[a], RGB(254,254,254) );
			//	ddckey.dwColorSpaceHighValue = DDColorMatch(g_pSprite[a], RGB(255,255,255) );
			//	g_pSprite[a]->SetColorKey(DDCKEY_SRCBLT,&ddckey);
			DDSetColorKey(g_pSprite[a],SpriteColor[a]);
			if(SpriteSurfaceBmp[a]){
				SetupBitmapToSurface(SpriteSurfaceBmp[a],a);
			}else{
			   DDBLTFX     ddbltfx;
				ZeroMemory(&ddbltfx, sizeof(ddbltfx));
				ddbltfx.dwSize = sizeof(ddbltfx);
				ddbltfx.dwFillColor = RGB(0,0,0);
				g_pSprite[a]->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
			}
		}
	}
	XDraw_Use_Flag=1;
	GetDesktopColor();
    return DD_OK;
}




//-----------------------------------------------------------------------------
// Name: ChangeCoopLevel()
// Desc: Called when the user wants to toggle between Full-Screen & Windowed
//-----------------------------------------------------------------------------
HRESULT XDraw::ChangeCoopLevel(HWND hWnd )
{
    HRESULT hRet;
	//ʂ̕ۑ
	SetupSurfaceToBitmap(BGBmp,DRAW_BG);
	SetupSurfaceToBitmap(BGSurfaceBmp,DRAW_BG_SURFACE);
	for(int a=0;a<SpriteMaxPage;++a){
		SetupSurfaceToBitmap(SpriteSurfaceBmp[a],a);
	}
//	MessageBox(NULL,"","",MB_OK);

    // Release all objects that need to be re-created for the new device
    if (FAILED(hRet = ReleaseAllObjects(hWnd)))
        return InitFail(hWnd, hRet, "ReleaseAllObjects FAILED");

    // In case we're coming from a fullscreen mode, restore the window size
    if (g_bWindowed)
    {
        SetWindowPos(hWnd, HWND_NOTOPMOST, g_rcWindow.left, g_rcWindow.top,
                     (g_rcWindow.right - g_rcWindow.left), 
                     (g_rcWindow.bottom - g_rcWindow.top), SWP_SHOWWINDOW );
    }

    // Re-create the surfaces
    hRet = InitSurfaces(hWnd,SpriteMaxPage);
    return hRet;
}


void XDraw::TaskPaint()
{
	HRESULT         hRet;
	if (g_bWindowed && g_bReady)
	{
		while (TRUE)
		{
			// If we are in windowed mode, perform a blt.
			hRet = g_pDDSPrimary->Blt(&g_rcScreen, g_pDDSBack,
									  &g_rcViewport, DDBLT_WAIT,
									  NULL);
			if (hRet == DD_OK)
				break;
			if (hRet == DDERR_SURFACELOST)
			{
				hRet = g_pDDSPrimary->Restore();
				if (hRet != DD_OK )
					break;
			}
			if (hRet != DDERR_WASSTILLDRAWING)
				break;
		}
	}
}
static HMENU hMenu=NULL;
static LONG style=WS_POPUP;
int XDraw::KeepMenu()
{
	int result=0;
	HMENU h=GetMenu(XDraw_hWnd);
	if(h){
		hMenu=h;
		SetMenu(XDraw_hWnd,NULL);
		result= 1;
	}
	style=GetWindowLong(XDraw_hWnd,GWL_STYLE);
	SetWindowLong(XDraw_hWnd,GWL_STYLE,WS_POPUP);//WS_DLGFRAME
	char moji[256];
	wsprintf(moji,"KEEP STYLE %d\n",style);
	OutputDebugString(moji);
	return result;
}
int XDraw::RestoreMenu()
{
	int result=0;
	HMENU h=GetMenu(XDraw_hWnd);
	if(h==0){
		if(hMenu)
			SetMenu(XDraw_hWnd,hMenu);
		hMenu=NULL;
	}
	SetWindowLong(XDraw_hWnd,GWL_STYLE,style);//WS_SYSMENU	WS_CAPTION
	char moji[256];
	wsprintf(moji,"RESTORE STYLE %d\n",style);
	OutputDebugString(moji);
	result= 1;
	return result;
}
void XDraw::SetFullScreen()
{
    if (g_bActive && g_bReady)
    {
        if (g_bWindowed){
			HWND hWnd=GetDrawHWND();
 			 g_bReady = FALSE;
		   GetWindowRect(hWnd, &g_rcWindow);
			KeepMenu();
	        g_bWindowed = !g_bWindowed;
			ChangeScreenFlag=1;
		}
    }
}
void XDraw::SetWindowScreen()
{
    if (g_bActive && g_bReady)
    {
        if (!g_bWindowed){
 			HWND hWnd=GetDrawHWND();
 			 g_bReady = FALSE;
			GetWindowRect(hWnd, &g_rcWindow);
			g_rcWindow.right=g_rcWindow.left+DisplayWidth+GetSystemMetrics(SM_CXSIZEFRAME)*2;
			g_rcWindow.bottom=g_rcWindow.top+DisplayHeight+GetSystemMetrics(SM_CYSIZEFRAME)*2
								   +GetSystemMetrics(SM_CYMENU);
			GetClientRect(hWnd, &g_rcViewport);
			GetClientRect(hWnd, &g_rcScreen);
			g_rcViewport.right=g_rcViewport.left+DisplayWidth;
			g_rcViewport.bottom=g_rcViewport.top+DisplayHeight;
			g_rcScreen.right=g_rcScreen.left+DisplayWidth;
			g_rcScreen.bottom=g_rcScreen.top+DisplayHeight;
			RestoreMenu();
			g_bWindowed = !g_bWindowed;
			ChangeScreenFlag=1;
 		}

    }
}
int XDraw::ToggleFullScreen()
{
    if (g_bActive && g_bReady)
    {
        g_bReady = FALSE;
		HWND hWnd=GetDrawHWND();
        if (g_bWindowed){
            GetWindowRect(hWnd, &g_rcWindow);
			KeepMenu();
		}else{
            GetWindowRect(hWnd, &g_rcWindow);
			g_rcWindow.right=g_rcWindow.left+DisplayWidth+GetSystemMetrics(SM_CXSIZEFRAME)*2;
			g_rcWindow.bottom=g_rcWindow.top+DisplayHeight+GetSystemMetrics(SM_CYSIZEFRAME)*2
								   +GetSystemMetrics(SM_CYMENU);
			GetClientRect(hWnd, &g_rcViewport);
			GetClientRect(hWnd, &g_rcScreen);
			g_rcViewport.right=g_rcViewport.left+DisplayWidth;
			g_rcViewport.bottom=g_rcViewport.top+DisplayHeight;
			g_rcScreen.right=g_rcScreen.left+DisplayWidth;
			g_rcScreen.bottom=g_rcScreen.top+DisplayHeight;
			RestoreMenu();
		}

        g_bWindowed = !g_bWindowed;
		ChangeScreenFlag=1;
    }
	return 0;
}
void XDraw::TaskMove()
{
//	if (g_bActive && g_bReady && g_bWindowed)
	HWND hWnd=GetDrawHWND();
	if(hWnd){
		GetWindowRect(hWnd, &g_rcWindow);
		GetClientRect(hWnd, &g_rcViewport);
		GetClientRect(hWnd, &g_rcScreen);
		ClientToScreen(hWnd, (POINT*)&g_rcScreen.left);
		ClientToScreen(hWnd, (POINT*)&g_rcScreen.right);

			g_rcWindow.right=g_rcWindow.left+DisplayWidth+GetSystemMetrics(SM_CXSIZEFRAME)*2;
			g_rcWindow.bottom=g_rcWindow.top+DisplayHeight+GetSystemMetrics(SM_CYSIZEFRAME)*2
								   +GetSystemMetrics(SM_CYMENU);
			g_rcViewport.right=g_rcViewport.left+DisplayWidth;
			g_rcViewport.bottom=g_rcViewport.top+DisplayHeight;
			g_rcScreen.right=g_rcScreen.left+DisplayWidth;
			g_rcScreen.bottom=g_rcScreen.top+DisplayHeight;
	}
}
static BOOL            page = FALSE;   // Which screen to render (Front or Back text)
void XDraw::TaskSize(LPARAM lParam)
{
// WM_GETMINMAXINFOĂяoƃEBhETCYŒ肳
    MINMAXINFO      *pMinMax;
	pMinMax = (MINMAXINFO *)lParam;
	pMinMax->ptMinTrackSize.x = DisplayWidth+GetSystemMetrics(SM_CXSIZEFRAME)*2;
	pMinMax->ptMinTrackSize.y = DisplayHeight+GetSystemMetrics(SM_CYSIZEFRAME)*2
								   +GetSystemMetrics(SM_CYMENU);
	pMinMax->ptMaxTrackSize.x = pMinMax->ptMinTrackSize.x;
	pMinMax->ptMaxTrackSize.y = pMinMax->ptMinTrackSize.y;
}
void XDraw::QuitXDraw()
{
   // Release the main DDraw interface
    if (g_pDD){
        g_pDD->Release();
	}
}
//---------------------------------
void XDraw::SetSprite(int pa,int x,int y,int w,int h,int page)
{
	if(page<0 || page>=SpriteMaxPage)
		return;
	if(pa<0 || pa>=MAX_SPRITE)
		return;
	int sx=x,sy=y;
	int ex=x+w,ey=y+h;
	if(sx<0)	sx=0;
	if(sy<0)	sy=0;
	if(ex>DisplayWidth)		ex=DisplayWidth;
	if(ey>DisplayHeight)	ey=DisplayHeight;
	SpritePa[pa].x=sx;
	SpritePa[pa].y=sy;
	SpritePa[pa].w=ex-sx;
	SpritePa[pa].h=ey-sy;
	SpritePa[pa].page=page;
}
void XDraw::PutSprite(int num,int x,int y,int pa,int zoomx,int zoomy,int hflag)
{
	if(pa<0 || pa>=MAX_SPRITE)
		return;
	if(num<0 || num>=MAX_SPRITE)
		return;
	int dvx=0,dvy=0;
	int sx=x,sy=y;
	int ex=x+SpritePa[pa].w,ey=y+SpritePa[pa].h;
	if(sx<0){
		dvx=-sx;
		sx=0;
	}
	if(sy<0){
		dvy=-sy;
		sy=0;
	}
	if(ex>DisplayWidth)		ex=DisplayWidth;
	if(ey>DisplayHeight)	ey=DisplayHeight;
	SpriteAt[num].x=sx;
	SpriteAt[num].y=sy;
	SpriteAt[num].w=ex-sx;
	SpriteAt[num].h=ey-sy;
	SpriteAt[num].page=SpritePa[pa].page;
	SpriteAt[num].px=SpritePa[pa].x+dvx;
	SpriteAt[num].py=SpritePa[pa].y+dvy;
	SpriteAt[num].zoomx=zoomx;
	SpriteAt[num].zoomy=zoomy;
	SpriteAt[num].hflag=hflag;
}
void XDraw::EraseSprite(int num)
{
	if(num<0 || num>=MAX_SPRITE)
		return;
	SpriteAt[num].w=0;
	SpriteAt[num].h=0;
}
#define SETUP_DC \
	LPDIRECTDRAWSURFACE7 draw; \
	draw=g_pDDSBack; \
	switch(page){ \
		case DRAW_BG_SURFACE: \
			draw=g_pBGSurface; \
		break; \
		case DRAW_BG:	 \
				draw=g_pBG; \
		break; \
		case DRAW_SELECT: \
			if(UseSpriteFlag==0) \
				draw=g_pDDSBack; \
			else \
				draw=g_pBG; \
		break; \
		case DRAW_SELF: \
		case DRAW_WINDOW: \
		case DRAW_DIRECT: \
			draw=g_pDDSBack; \
			break; \
		default: \
			if(page>=0 && page<SpriteMaxPage) \
			draw=g_pSprite[page]; \
		break; \
	}

void XDraw::SetupBitmapToSurface(HBITMAP hBmp,int page)
{//HBITMAPT[tFXɏ
	if(IsWindow(XDraw_hWnd)==0 || hBmp==NULL)
		return;
	SETUP_DC
	HDC hDC;
	if(draw->GetDC(&hDC) == DD_OK) {
			BITMAP bmp;
			GetObject(hBmp,sizeof(BITMAP),&bmp);

			HDC dc=GetDC(NULL);
			HDC hMemDC=CreateCompatibleDC(dc);
			HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp);
			BitBlt(hDC,0,0,bmp.bmWidth,bmp.bmHeight,hMemDC,0,0,SRCCOPY);		

			SelectObject(hMemDC,hBmpOld);
			DeleteDC(hMemDC);
			ReleaseDC(NULL,dc);
		draw->ReleaseDC(hDC);
	}

/*
		{
			HDC dc=GetDC(NULL);
			HDC hMemDC=CreateCompatibleDC(dc);
			HBITMAP hold=(HBITMAP)SelectObject(hMemDC,hBufferBmp);

				HBRUSH hbr=CreateSolidBrush(0);
				RECT r;
				r.left=0;
				r.top=0;
				r.right=x;//+1;//2002-3-25ύX
				r.bottom=y;//+1;//2002-3-25ύX
				FillRect(hMemDC,&r,hbr);
				DeleteObject(hbr);
			SelectObject(hMemDC,hold);
			ReleaseDC(NULL,dc);
		}*/
}
void XDraw::SetupSurfaceToBitmap(HBITMAP hBmp,int page)
{//T[tFXHBITMAPɏ
	if(IsWindow(XDraw_hWnd)==0 || hBmp==NULL)
		return;
	SETUP_DC
	HDC hDC;
		BITMAP bmp;
		GetObject(hBmp,sizeof(BITMAP),&bmp);
		HDC dc=GetDC(NULL);
		HDC hMemDC=CreateCompatibleDC(dc);
		HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp);
	if(draw->GetDC(&hDC) == DD_OK) {
		BitBlt(hMemDC,0,0,bmp.bmWidth,bmp.bmHeight,hDC,0,0,SRCCOPY);		
		draw->ReleaseDC(hDC);
	}else{
		OutputDebugString("T[tFXRs[̎s!\n");
	}
//		BitBlt(dc,0,0,bmp.bmWidth,bmp.bmHeight,hMemDC,0,0,SRCCOPY);		
		SelectObject(hMemDC,hBmpOld);
		DeleteDC(hMemDC);
		ReleaseDC(NULL,dc);
}
void XDraw::CopyBitmap(HBITMAP hBmp1,HBITMAP hBmp2)
{
		BITMAP bmp;
		GetObject(hBmp2,sizeof(BITMAP),&bmp);
		HDC dc=GetDC(NULL);
		HDC hMemDC=CreateCompatibleDC(dc);
		HDC hMemDC2=CreateCompatibleDC(dc);
		HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp1);
		HBITMAP hBmp2Old=(HBITMAP)SelectObject(hMemDC2,hBmp2);
		BitBlt(hMemDC,0,0,bmp.bmWidth,bmp.bmHeight,hMemDC2,0,0,SRCCOPY);
		SelectObject(hMemDC2,hBmp2Old);
		SelectObject(hMemDC,hBmpOld);
		DeleteDC(hMemDC2);
		DeleteDC(hMemDC);
		ReleaseDC(NULL,dc);
}
void XDraw::CopyBitmap(HBITMAP hBmp1,int dest_x,int dest_y,int width,int height,HBITMAP hBmp2,int src_x,int src_y)
{
	if(hBmp2==NULL)
		return;
	BITMAP bmp;
	GetObject(hBmp2,sizeof(BITMAP),&bmp);
	HDC dc=GetDC(NULL);
	HDC hMemDC=CreateCompatibleDC(dc);
	HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp1);
	HDC hMemDC2=CreateCompatibleDC(dc);
	HBITMAP hBmp2Old=(HBITMAP)SelectObject(hMemDC2,hBmp2);
	if(width==-1)
		width=bmp.bmWidth;
	if(height==-1)
		height=bmp.bmHeight;
	BitBlt(hMemDC,dest_x,dest_y,width,height,hMemDC2,src_x,src_y,SRCCOPY);
	SelectObject(hMemDC2,hBmp2Old);
	SelectObject(hMemDC,hBmpOld);
	DeleteDC(hMemDC2);
	DeleteDC(hMemDC);
	ReleaseDC(NULL,dc);
}
RECT XDraw::LoadSpriteData(LPSTR s,int color,int page)
{
	RECT r={0,0,0,0};
	if(page>SpriteMaxPage)
		return r;
	if(IsWindow(XDraw_hWnd)==0)
		return r;
	FILE *fp2;//t@C̃`FbN
	fp2=fopen(s,"r");
	if(fp2==NULL)
		return r;
	fclose(fp2);
	SpriteColor[page]=color;

	HBITMAP hBmp = (HBITMAP)LoadImage(NULL, s, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if(hBmp){
		//if(SpriteSurfaceBmp[page])
		//	DeleteObject(SpriteSurfaceBmp[page]);
		//SpriteSurfaceBmp[page]=hBmp;
		BITMAP bmp;
		GetObject(hBmp,sizeof(BITMAP),&bmp);
		HDC hDC;
		HDC dc=GetDC(NULL);
		HDC hMemDC=CreateCompatibleDC(dc);
		HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp);
		{
			HDC hMemDC2=CreateCompatibleDC(dc);
			HBITMAP hBmp2Old=(HBITMAP)SelectObject(hMemDC2,SpriteSurfaceBmp[page]);
			BitBlt(hMemDC2,0,0,bmp.bmWidth,bmp.bmHeight,hMemDC,0,0,SRCCOPY);
			SelectObject(hMemDC2,hBmp2Old);
			DeleteDC(hMemDC2);
		}
		if(g_pSprite[page]->GetDC(&hDC) == DD_OK) {
			BitBlt(hDC,0,0,bmp.bmWidth,bmp.bmHeight,hMemDC,0,0,SRCCOPY);		
			g_pSprite[page]->ReleaseDC(hDC);
		}

		SelectObject(hMemDC,hBmpOld);
		DeleteDC(hMemDC);
		ReleaseDC(NULL,dc);
			// J[EL[ݒ肷
			DDCOLORKEY ddckey;
			ddckey.dwColorSpaceLowValue = DDColorMatch(g_pSprite[page], SpriteColor[page] );
			ddckey.dwColorSpaceHighValue = ddckey.dwColorSpaceLowValue;
			g_pSprite[page]->SetColorKey(DDCKEY_SRCBLT,&ddckey);

		RECT r;
		r.left=0;
		r.top=0;
		r.right=bmp.bmWidth;
		r.bottom=bmp.bmHeight;
		DeleteObject(hBmp);
		return r;
	}else{
		return r;
	}
}
void XDraw::LoadBGData(LPSTR s)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	FILE *fp2;//t@C̃`FbN
	fp2=fopen(s,"r");
	if(fp2==NULL)
		return;
	fclose(fp2);

	HBITMAP hBmp = (HBITMAP)LoadImage(NULL, s, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	if(hBmp){
		if(BGSurfaceBmp)
			DeleteObject(BGSurfaceBmp);
		BGSurfaceBmp=hBmp;
		BITMAP bmp;
		GetObject(hBmp,sizeof(BITMAP),&bmp);
		HDC hDC;
		HDC dc=GetDC(NULL);
		HDC hMemDC=CreateCompatibleDC(dc);
		HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp);
		if(g_pBGSurface->GetDC(&hDC) == DD_OK) {
			BitBlt(hDC,0,0,bmp.bmWidth,bmp.bmHeight,hMemDC,0,0,SRCCOPY);		
			g_pBGSurface->ReleaseDC(hDC);
		}

		SelectObject(hMemDC,hBmpOld);
		DeleteDC(hMemDC);
		ReleaseDC(NULL,dc);
	}
}
void XDraw::Pset(int x,int y,int color,int page)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC
	HDC hDC;
	if(draw->GetDC(&hDC) == DD_OK) {
		SetPixelV(hDC,x,y,color);
		draw->ReleaseDC(hDC);
	}

}
COLORREF XDraw::Pget(int x,int y,int page)
{
	if(IsWindow(XDraw_hWnd)==0)
		return 0;
	SETUP_DC
	HDC hDC;
	int c=0;
	if(draw->GetDC(&hDC) == DD_OK) {
		c=GetPixel(hDC,x,y);
		draw->ReleaseDC(hDC);
	}
	return c;

}
void XDraw::Line(int x,int y,int w,int h,int color,int page)
{
	if(page>SpriteMaxPage)
		return;
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC
	HDC hDC;
	if(draw->GetDC(&hDC) == DD_OK) {
		POINT point;
		HPEN hpen=CreatePen(PS_SOLID	, 1, color);
		HPEN hpenold=(HPEN)SelectObject(hDC,hpen);
		MoveToEx(hDC,x,y,&point);
		LineTo(hDC,x+w,y+h);
		SelectObject(hDC,hpenold);
		DeleteObject(hpen);

		draw->ReleaseDC(hDC);
	}
}
void XDraw::Line2(int x,int y,int x2,int y2,int color,int page)
{
	if(page>SpriteMaxPage)
		return;
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC
	HDC hDC;
	if(draw->GetDC(&hDC) == DD_OK) {
		POINT point;
		HPEN hpen=CreatePen(PS_SOLID	, 1, color);
		HPEN hpenold=(HPEN)SelectObject(hDC,hpen);
		MoveToEx(hDC,x,y,&point);
		LineTo(hDC,x2,y2);
		SelectObject(hDC,hpenold);
		DeleteObject(hpen);
		draw->ReleaseDC(hDC);
	}
}
//
void XDraw::SurfaceBlt(int dx,int dy,int w,int h,int dpage,int sx,int sy,int spage)
{
	if(dpage<0 || dpage>=MAX_SPRITE)
		return;
	if(spage<0 || spage>=MAX_SPRITE)
		return;
	if(IsWindow(XDraw_hWnd)==0)
		return;
	RECT sr;
	sr.left=sx;
	sr.top=sy;
	sr.right=sx+w;
	sr.bottom=sy+h;
	g_pSprite[dpage]->BltFast(dx,dy, g_pSprite[spage],  &sr, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);// 

}
void XDraw::PutBGChip(int x,int y,int w,int h,int src_x,int src_y)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	RECT sr;
	sr.left=src_x;
	sr.top=src_y;
	sr.right=src_x+w;
	sr.bottom=src_y+h;
	g_pBG->BltFast(x,y, g_pBGSurface,  &sr, DDBLTFAST_WAIT);// 
}
void XDraw::DrawTextBold(char* text,int x,int y,int Color,int Size,int page,int Color2)
{//Color2Ńt`t̕`
	//`
	DrawText2(text,x-1,y+0,Color2,Size,page,1);
	DrawText2(text,x+1,y+0,Color2,Size,page,1);
	DrawText2(text,x+0,y-1,Color2,Size,page,1);
	DrawText2(text,x+0,y+1,Color2,Size,page,1);
	//
/*
	DrawText(text,x-1,y-1,Color2,Size,page,paintflag);
	DrawText(text,x+1,y-1,Color2,Size,page,paintflag);
	DrawText(text,x-1,y+1,Color2,Size,page,paintflag);
	DrawText(text,x+1,y+1,Color2,Size,page,paintflag);
	*/
	//`
	DrawText2(text,x,y,Color,Size,page,1);
	if(page>=0){
		int len=strlen(text);
	//	MakeMaskData(page,SpriteColor[page],x-1,y-1,len*(Size/2)+2,Size+2);
	}
}
void XDraw::DrawText2(char * Text, int x, int y, int Color, int Size,int page,int paintflag)
{
	if(page>SpriteMaxPage)
		return;
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC
	HFONT hFont=CreateFont(Size,0, 0, 0,
		FW_DONTCARE	, FALSE, FALSE, FALSE, 
		SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS 
	, CLIP_DEFAULT_PRECIS,	DEFAULT_QUALITY	,
	DEFAULT_PITCH | FF_ROMAN	, FontName[FontType]);
	HDC hDC;
	if(draw->GetDC(&hDC) == DD_OK) {
		if(paintflag)
			SetBkMode(hDC, TRANSPARENT);

		HFONT hFontOld=(HFONT)SelectObject(hDC,hFont);
		SetTextColor(hDC,Color);
		int len=strlen(Text);
		TextOut(hDC,x,y,Text,len);
		SelectObject(hDC,hFontOld);
		DeleteObject(hFont);
		draw->ReleaseDC(hDC);
	}

}
void XDraw::DrawText(char * Text, int x, int y, int Color, int Size,int page,int paintflag)
{
	if(page>SpriteMaxPage)
		return;
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC


	HFONT hFont=CreateFont(Size,0, 0, 0,
		FW_DONTCARE	, FALSE, FALSE, FALSE, 
		SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS 
	, CLIP_DEFAULT_PRECIS,	DEFAULT_QUALITY	,
	DEFAULT_PITCH | FF_ROMAN	,FontName[FontType]);
	HDC hDC;
	if(draw->GetDC(&hDC) == DD_OK) {
		if(paintflag)
			SetBkMode(hDC, TRANSPARENT);
		else
			SetBkMode(hDC, OPAQUE);

		HFONT hFontOld=(HFONT)SelectObject(hDC,hFont);
		SetTextColor(hDC,Color);
		int len=strlen(Text);
		TextOut(hDC,x,y,Text,len);
		SelectObject(hDC,hFontOld);
		DeleteObject(hFont);
		draw->ReleaseDC(hDC);
	}

}
void XDraw::Box(int x1, int y1, int x2, int y2, int color,int page)
{
	if(page>SpriteMaxPage)
		return;
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC

	--x2;//2002-3-25C
	--y2;//2002-3-25C
	POINT p[5];
	p[0].x=x1;
	p[0].y=y1;
	p[1].x=x1;
	p[1].y=y1+y2;
	p[2].x=x1+x2;
	p[2].y=y1+y2;
	p[3].x=x1+x2;
	p[3].y=y1;
	p[4].x=x1;
	p[4].y=y1;
	HDC hDC;
	if(draw->GetDC(&hDC) == DD_OK) {
		HPEN hPen=CreatePen(PS_SOLID,PenWidth,color);
		HPEN hPenOld=(HPEN)SelectObject(hDC,hPen);
		Polyline(hDC,p,5);
		SelectObject(hDC,hPenOld);
		DeleteObject(hPen);
		if(page>=0)
			MakeMaskData(page,SpriteColor[page],x1,y1,x2,y2);
		draw->ReleaseDC(hDC);
	}
}
void XDraw::ClearSurface(int page)
{
	if(page>SpriteMaxPage)
		return;
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC
	DDBLTFX     ddbltfx;
	ZeroMemory(&ddbltfx, sizeof(ddbltfx));
	ddbltfx.dwSize = sizeof(ddbltfx);
	int c=0;
	if(page>=0)
		c = SpriteColor[page];
	else
		c = XRGB(0,0,0);
	if(DesktopColor==16)
		ddbltfx.dwFillColor = Color32To16(c,SurfaceColorBit);
	else
		ddbltfx.dwFillColor = c;
	draw->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
}
void XDraw::BoxFill(int x1, int y1, int x2, int y2, int color,int page)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC
	HDC hDC;
	if(draw->GetDC(&hDC) == DD_OK) {
		HBRUSH hbr=CreateSolidBrush(color);
		RECT r;
		r.left=x1;
		r.top=y1;
		r.right=x1+x2;//+1;//2002-3-25ύX
		r.bottom=y1+y2;//+1;//2002-3-25ύX
		FillRect(hDC,&r,hbr);
		DeleteObject(hbr);

		draw->ReleaseDC(hDC);
	}
}
void XDraw::Arc(int x,int y,int r,int color,int page)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC
	HDC hDC;
	if(draw->GetDC(&hDC) == DD_OK) {
		HPEN hPen=CreatePen(PS_SOLID,PenWidth,color);
		HPEN hPenOld=(HPEN)SelectObject(hDC,hPen);
		HBRUSH hbr=CreateSolidBrush(color);
		HBRUSH hbrold=(HBRUSH)SelectObject(hDC,hbr);
	//	Ellipse(hDC,x-r,y-r,x+r,y+r);
	//	AngleArc(hDC, x, y, r, 0.0, 3.14);
		::Arc(hDC, x-r, y-r, x+r, y+r, 0, 0,0, 0);
		SelectObject(hDC,hPenOld);
		SelectObject(hDC,hbrold);
		DeleteObject(hPen);
		DeleteObject(hbr);
		draw->ReleaseDC(hDC);
	}
}

void XDraw::Circle(int x,int y,int r,int color,int page)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC
	HDC hDC;
	if(draw->GetDC(&hDC) == DD_OK) {
		HPEN hPen=CreatePen(PS_SOLID,PenWidth,color);
		HPEN hPenOld=(HPEN)SelectObject(hDC,hPen);
		HBRUSH hbr=CreateSolidBrush(color);
		HBRUSH hbrold=(HBRUSH)SelectObject(hDC,hbr);
		Ellipse(hDC,x-r,y-r,x+r,y+r);
		SelectObject(hDC,hPenOld);
		SelectObject(hDC,hbrold);
		DeleteObject(hPen);
		DeleteObject(hbr);
		draw->ReleaseDC(hDC);
	}
}

int XDraw::GetDesktopColor()
{//ʂ̐F𒲂ׂ
	HDC hDC=GetDC(NULL);
	HBITMAP hBmp=CreateCompatibleBitmap(hDC, 1, 1);
	BITMAP Bmp;
	GetObject(hBmp,sizeof(BITMAP),&Bmp);
	DeleteObject(hBmp);
	ReleaseDC(NULL,hDC);
	char moji[256];
	if(g_bWindowed){
		DesktopColor=Bmp.bmBitsPixel;
		strcpy(moji,"`FW!Win");
	}else{
		DesktopColor=DisplayColor;
		strcpy(moji,"`FW!Full");
	}
	wsprintf(moji,"%s %dbit\n",moji,DesktopColor);
	OutputDebugString(moji);
	SurfaceColorBit=GetRGBBit();
	return(DesktopColor);
}
void XDraw::PutBitmap(HBITMAP hBmp,int x,int y,int w,int h,int page,int sx,int sy)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC
	HDC hDC;
	BITMAP bmp;
	if(draw->GetDC(&hDC) == DD_OK) {
		GetObject(hBmp,sizeof(BITMAP),&bmp);
		if(w==-1 || h==-1){
			w=bmp.bmWidth;
			h=bmp.bmHeight;
		}
		HDC hMemDC=CreateCompatibleDC(hDC);
		HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp);
		BitBlt(hDC,x,y,w,h,hMemDC,sx,sy,SRCCOPY);
		SelectObject(hMemDC,hBmpOld);
		DeleteDC(hMemDC);
		draw->ReleaseDC(hDC);
	}
}
void XDraw::PutBitmapColorKey(HBITMAP hBmp,int x,int y,int w,int h,int page,int sx,int sy)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC
	HDC hDC;
	BITMAP bmp;
		GetObject(hBmp,sizeof(BITMAP),&bmp);
		if(w==-1 || h==-1){
			w=bmp.bmWidth;
			h=bmp.bmHeight;
		}
	if(draw->GetDC(&hDC) == DD_OK) {
		HDC hMemDC=CreateCompatibleDC(hDC);
		HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp);
		BitBlt(hDC,x,y,w,h,hMemDC,sx,sy,SRCCOPY);
		SelectObject(hMemDC,hBmpOld);
		DeleteDC(hMemDC);
		draw->ReleaseDC(hDC);
		/*
			g_pDDSBack->Blt(&dr, g_pSprite[page],  &sr, DDBLT_WAIT ,  NULL);
			g_pBG->Blt(&dr, g_pSprite[page],  &sr, DDBLT_WAIT ,  NULL);
			g_pDDSBack->BltFast(dr.left,dr.top, g_pSprite[page],  &sr, DDBLTFAST_WAIT);// 
			g_pBG->BltFast(dr.left,dr.top, g_pSprite[page],  &sr, DDBLTFAST_WAIT);// 
			*/
		PutSpriteChip2(x,y,w,h,sx,sy,page,0,0,1);
	}
}
void XDraw::GetSurfaceToBitmap(HBITMAP hBmp,int page)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	SETUP_DC
	HDC hDC;
	//BITMAP bmp;
	if(draw->GetDC(&hDC) == DD_OK) {
		//GetObject(hBmp,sizeof(BITMAP),&bmp);

		HDC hMemDC=CreateCompatibleDC(hDC);
		HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,hBmp);
		BitBlt(hMemDC,0,0,640,480,hDC,0,0,SRCCOPY);
		SelectObject(hMemDC,hBmpOld);
		DeleteDC(hMemDC);
		draw->ReleaseDC(hDC);
	}
}
void XDraw::GetSurfaceToMemory(void* mem,int page)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;

	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
	static int rm=0,gm=0,bm=0;

	if(XDraw_Use_Flag==0)
		return;
	RECT rect={0};
	unsigned short int *dib=(unsigned short int *)mem;
	if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
		unsigned short int *lpPixel = (unsigned short int *)ddsd.lpSurface;
		rm=ddsd.ddpfPixelFormat.dwRBitMask;
		gm=ddsd.ddpfPixelFormat.dwGBitMask;
		bm=ddsd.ddpfPixelFormat.dwBBitMask;
		for(int i=0;i<640*480/4;++i){
			//*dib++=*lpPixel++;
			/*
			*(unsigned int*)(dib)=*(unsigned int*)lpPixel;
			dib+=2;
			lpPixel+=2;
			*/
			/*
			_asm{
				mov esi,lpPixel
				mov edi,dib
				movq mm0,[esi]
				movq [edi],mm0
				add esi,8
				add edi,8
				mov lpPixel,esi
				mov dib,edi
				emms
			}
			*/
			
			_asm{
				mov esi,lpPixel
				mov edi,dib
				movq mm0,[edi]
				movq [esi],mm0
				add esi,8
				add edi,8
				mov lpPixel,esi
				mov dib,edi
				emms
			}
		}
		g_pDDSBack->Unlock(&rect);
		//g_pDDSBack->Unlock(ddsd.lpSurface);
	}
}
HBITMAP XDraw::ReadBitmap(LPSTR FileName)
{
	HBITMAP hBmp = (HBITMAP)LoadImage(NULL, FileName, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	return(hBmp);
}
int XDraw::GetRGBBit(int *r,int *g,int *b)
{
	static unsigned int z;
	//RGBɎgrbgԂ
	//8,24,32bit̂Ƃ͂̂܂܁B
	//15,16bit̔ʂB
	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
	int rm=0,gm=0,bm=0;
	int flag=0;

	if(XDraw_Use_Flag==0)
		return 0;
	RECT rect={0};
	if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
		flag=1;
		unsigned short int *lpPixel = (unsigned short int *)ddsd.lpSurface;
		rm=ddsd.ddpfPixelFormat.dwRBitMask;
		gm=ddsd.ddpfPixelFormat.dwGBitMask;
		bm=ddsd.ddpfPixelFormat.dwBBitMask;
		g_pDDSBack->Unlock(&rect);
		//g_pDDSBack->Unlock(ddsd.lpSurface);
	}else{
		return -1;
	}
	if(r!=NULL)
		*r=rm;
	if(g!=NULL)
		*g=gm;
	if(b!=NULL)
		*b=bm;
	z=rm | gm | bm;
	int count=0;
	for(int a=0;a<32;++a){
		if(z&1)
			++count;
		z>>=1;
	}
	char moji[256];
	wsprintf(moji,"F̃rbg=%d\n",count);
	OutputDebugString(moji);
	return(count);
}
static unsigned short int Dummy[640*480];
int XDraw::Test()
{
	static int first=0;
	if(first==0){
		first=1;
		SetupSurfaceToBitmap(BGBmp,DRAW_BG);
	}
	static unsigned int z;
	//RGBɎgrbgԂ
	//8,24,32bit̂Ƃ͂̂܂܁B
	//15,16bit̔ʂB
	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
	int rm=0,gm=0,bm=0;
	int flag=0;

	RECT rect={0};
static	int w,color_t[2]={0xf800f800,0x001f001f},count=0;
	count=(count+1)&1;
	int color=color_t[count];
	if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
		flag=1;
		unsigned short int *lpPixel = (unsigned short int *)ddsd.lpSurface;
		rm=ddsd.ddpfPixelFormat.dwRBitMask;
		gm=ddsd.ddpfPixelFormat.dwGBitMask;
		bm=ddsd.ddpfPixelFormat.dwBBitMask;
		z=rm | gm | bm;
		w=ddsd.lPitch/4;
		if(z==0xffff || z==0x7fff){
			unsigned int *lpPixel = (unsigned int *)pBG;w=320/2;
//			unsigned int *lpPixel = (unsigned int *)ddsd.lpSurface;
			for(unsigned int y=0;y<ddsd.dwHeight;++y){
				int c=lpPixel[y*w];
				for(unsigned int x=0;x<(ddsd.dwWidth/2)-1 ;++x){
					lpPixel[x+y*w] = lpPixel[x+y*w+1];
				}
				lpPixel[(ddsd.dwWidth/2)-1+y*w] =c;
			}
		}
		g_pDDSBack->Unlock(&rect);
		SetupBitmapToSurface(BGBmp,DRAW_BG);
	}else{
		return -1;
	}
/*	if(w!=640){
		char moji[256];
		wsprintf(moji,"w=%d\n",w);
		OutputDebugString(moji);
	}*/

	return(z);
}
unsigned short int XDraw::Color32To16(unsigned int color,int bit)
{
	//RQrbgJ[PUrbgJ[ɕϊB
	//bit=15łPTrbgJ[ɑΉ
	unsigned short int result=0;
	if(bit==15){
		int b=(color>>3)&31;
		int g=(color>>(8+3))&31;
		int r=(color>>(16+3))&31;
		result=b | (g<<5) | (r<<10);
	}else{
		int b=(color>>3)&31;
		int g=(color>>(8+2))&63;
		int r=(color>>(16+3))&31;
		result=b | (g<<5) | (r<<11);
	}
	return result;
}
void XDraw::BlendChip(int x,int y,int w,int h,int src_x,int src_y,int page,int hflag)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	if(page<0 || page>=SpriteMaxPage)
		return;
	if(hflag==0){
		RECT dr,sr;
		dr.left=x;
		dr.top=y;
		dr.right=x+w;
		dr.bottom=y+h;
		sr.left=src_x;
		sr.top=src_y;
		{
			sr.right=src_x+w;
			sr.bottom=src_y+h;
			if(dr.right>DisplayWidth){
				sr.right=src_x + w - (dr.right-DisplayWidth);
				dr.right=DisplayWidth;
			}else{
				if(dr.left<0){
					sr.left=src_x -(dr.left);
					dr.left=0;
				}
			}
			if(dr.bottom>DisplayHeight){
				sr.bottom=src_y + h - (dr.bottom-DisplayHeight);
				dr.bottom=DisplayHeight;
			}else{
				if(dr.top<0){
					sr.top= src_y -(dr.top);
					dr.top=0;
				}
			}
		}
    DDBLTFX     ddbltfx;
    ZeroMemory(&ddbltfx, sizeof(ddbltfx));
    ddbltfx.dwSize = sizeof(ddbltfx);
    ddbltfx.dwFillColor = RGB(0,0,255);
	ddbltfx.dwROP=SRCPAINT;
	ddbltfx.dwDDFX =DDBLTFX_MIRRORLEFTRIGHT | DDBLTFX_MIRRORUPDOWN  ;
	ddbltfx.dwROP =0;
   // g_pDDSBack->Blt(NULL, NULL, NULL, DDBLT_COLORFILL | DDBLT_WAIT, &ddbltfx);
	//		if(zoomx!=0 || zoomy!=0){
			g_pDDSBack->Blt(&dr, g_pSprite[page],  &sr, DDBLT_DDFX    ,  &ddbltfx);//| DDBLT_KEYSRC DDBLT_ROP
//		}else{
//			g_pDDSBack->BltFast(dr.left,dr.top, g_pSprite[page],  &sr, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);// 
//		}
		return;
	}
}
void XDraw::PutSpriteChip(int x,int y,int w,int h,int src_x,int src_y,int page,int zoomx,int zoomy,int hflag)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	if(page<0 || page>=SpriteMaxPage)
		return;
	if(hflag==0){
		RECT dr,sr;
		dr.left=x;
		dr.top=y;
		dr.right=x+w;
		dr.bottom=y+h;
		sr.left=src_x;
		sr.top=src_y;
		if(zoomx!=0 || zoomy!=0){
			sr.right=src_x+w;
			sr.bottom=src_y+h;
			dr.right=x+zoomx;
			dr.bottom=y+zoomy;
			if(dr.right>DisplayWidth){
				sr.right=src_x + w - (dr.right-DisplayWidth)/2;
				dr.right=DisplayWidth;
			}else{
				if(dr.left<0){
					sr.left=src_x -(dr.left/2);
					dr.left=0;
				}
			}
			if(dr.bottom>DisplayHeight){
				sr.bottom=src_y + h - (dr.bottom-DisplayHeight)/2;
				dr.bottom=DisplayHeight;
			}else{
				if(dr.top<0){
					sr.top= src_y -(dr.top/2);
					dr.top=0;
				}
			}
		}else{
			sr.right=src_x+w;
			sr.bottom=src_y+h;
			if(dr.right>DisplayWidth){
				sr.right=src_x + w - (dr.right-DisplayWidth);
				dr.right=DisplayWidth;
			}else{
				if(dr.left<0){
					sr.left=src_x -(dr.left);
					dr.left=0;
				}
			}
			if(dr.bottom>DisplayHeight){
				sr.bottom=src_y + h - (dr.bottom-DisplayHeight);
				dr.bottom=DisplayHeight;
			}else{
				if(dr.top<0){
					sr.top= src_y -(dr.top);
					dr.top=0;
				}
			}
		}
		if(zoomx!=0 || zoomy!=0){
			g_pDDSBack->Blt(&dr, g_pSprite[page],  &sr, DDBLT_WAIT | DDBLT_KEYSRC ,  NULL);
		}else{
			g_pDDSBack->BltFast(dr.left,dr.top, g_pSprite[page],  &sr, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);// 
		}
		return;
	}
	static unsigned int z;
	//RGBɎgrbgԂ
	//8,24,32bit̂Ƃ͂̂܂܁B
	//15,16bit̔ʂB
	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
	DDSURFACEDESC2 ddsd2;
	ZeroMemory(&ddsd2, sizeof(DDSURFACEDESC));
	ddsd2.dwSize = sizeof(ddsd2);
	int rm=0,gm=0,bm=0;
	int flag=0;

	RECT rect={0};
	RECT rect2={0};
	static int check=0;
	unsigned short int sp_color = Color32To16(SpriteColor[page],SurfaceColorBit);
	int width1,width2;
	if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
		if(g_pSprite[page]->Lock(&rect2, &ddsd2, DDLOCK_WAIT, NULL) == DD_OK) {
			flag=1;
			unsigned short int *lpPixel = (unsigned short int *)ddsd.lpSurface;
			rm=ddsd.ddpfPixelFormat.dwRBitMask;
			gm=ddsd.ddpfPixelFormat.dwGBitMask;
			bm=ddsd.ddpfPixelFormat.dwBBitMask;
			z=rm | gm | bm;
			switch(hflag){
				case 1://E]
					break;
				case 2://㉺]
					break;
				case 4://Z
				//	break;
				case 8://
					if(z==0xffff){//15rbgA16rbĝƂ
						width1=ddsd.lPitch/2;
						width2=ddsd2.lPitch/2;
						unsigned short int *pOut = (unsigned short int *)ddsd.lpSurface;
						unsigned short int *pIn = (unsigned short int *)ddsd2.lpSurface;

						if(w&1){
							for(int dy=0;dy<h;++dy){
								int ad_d=x+(dy+y)*width1;
								int ad_s=src_x+(dy+src_y)*width2;
								unsigned short int *pOut = (unsigned short int *)ddsd.lpSurface;
								unsigned short int *pIn = (unsigned short int *)ddsd2.lpSurface;
								pOut+=ad_d;
								pIn+=ad_s;
								for(int dx=0;dx<w ;++dx){
									unsigned short int c = *pIn;
									if(sp_color!=c){
										c = (c>>1)& 0x7bef;
										unsigned short int d = (*pOut>>1)& 0x7bef;
										*pOut =  d+c;
									}
									pOut++;
									pIn++;
								}
							}
						}else{
							unsigned int sp_c=(sp_color<<16) | sp_color; 
							width1/=2;
							width2/=2;
							for(int dy=0;dy<h;++dy){
								int ad_d=x/2+(dy+y)*width1;
								int ad_s=src_x/2+(dy+src_y)*width2;
								unsigned int *pOut = (unsigned int *)ddsd.lpSurface;
								unsigned int *pIn = (unsigned int *)ddsd2.lpSurface;
								pOut+=ad_d;
								pIn+=ad_s;
								for(int dx=0;dx<w/2 ;++dx){
									unsigned int c = *pIn;
									if(sp_c!=c){
										c = (c>>1)& 0x7bef7bef;
										unsigned int d = (*pOut>>1)& 0x7bef7bef;
										*pOut =  d+c;
									}
									pOut++;
									pIn++;
								}
							}
						
						}
					}else if(z== 0x7fff){
						width1=ddsd.lPitch/2;
						width2=ddsd2.lPitch/2;
						unsigned short int *pOut = (unsigned short int *)ddsd.lpSurface;
						unsigned short int *pIn = (unsigned short int *)ddsd2.lpSurface;

						for(int dy=0;dy<h;++dy){
							int ad_d=x+(dy+y)*width1;
							int ad_s=src_x+(dy+src_y)*width2;
							for(int dx=0;dx<w ;++dx){
								unsigned short int c = pIn[dx+ad_s];
								if(sp_color!=c){
									c = (c>>1)& 0x3def;
									unsigned short int d = (pOut[dx+ad_d]>>1)& 0x3def;
									pOut[dx+ad_d] =  c;
								}
							}
						}
					}else if(z == 0xffffff){
						if(DesktopColor==24){
							/*width1=ddsd.lPitch;
							width2=ddsd2.lPitch;
							unsigned char *pOut = (unsigned char *)ddsd.lpSurface;
							unsigned char *pIn = (unsigned char *)ddsd2.lpSurface;

							for(int dy=0;dy<h;++dy){
								int ad_d=x*3+(dy+y)*width1;
								int ad_s=src_x*3+(dy+src_y)*width2;
								for(int dx=0;dx<w*3 ;dx+=3){
									unsigned char db=pOut[dx+ad_d];
									unsigned char dg=pOut[dx+ad_d+1];
									unsigned char dr=pOut[dx+ad_d+2];
									unsigned char sb=pIn[dx+ad_s];
									unsigned char sg=pIn[dx+ad_s+1];
									unsigned char sr=pIn[dx+ad_s+2];
									if((signed)SpriteColor[page]!=(sb | (sg<<8) | (sr<<16))){
										pOut[dx+ad_d] =  (db>>1) + (sb>>1);
										pOut[dx+ad_d+1] =  (dg>>1) + (sg>>1);
										pOut[dx+ad_d+2] =  (dr>>1) + (sr>>1);
									}
								}
							}*/
							width1=ddsd.lPitch;
							width2=ddsd2.lPitch;

							int spc=SpriteColor[page];
							for(int dy=0;dy<h;++dy){
								unsigned char *pOut = (unsigned char *)ddsd.lpSurface;
								unsigned char *pOut2;// = (unsigned char *)ddsd.lpSurface;
								unsigned char *pIn = (unsigned char *)ddsd2.lpSurface;
								int ad_d=x*3+(dy+y)*width1;
								int ad_s=src_x*3+(dy+src_y)*width2;
								pIn +=ad_s;
								pOut +=ad_d;
								for(int dx=0;dx<w*3 ;dx+=3){
									pOut2=pOut;
									unsigned int c1=*((unsigned int*)pOut);
									unsigned int c2=*((unsigned int*)pIn);
									unsigned char db=(c1&255);
									unsigned char dg=(c1>>8)&255;
									unsigned char dr=(c1>>16)&255;
									unsigned char sb=c2&255;
									unsigned char sg=(c2>>8)&255;
									unsigned char sr=(c2>>16)&255;
									pOut+=3;
									pIn+=3;
								//	unsigned char db=*pOut;++pOut;
								//	unsigned char dg=*pOut;++pOut;
								//	unsigned char dr=*pOut;++pOut;
								//	unsigned char sb=*pIn;++pIn;
								//	unsigned char sg=*pIn;++pIn;
								//	unsigned char sr=*pIn;++pIn;
									if((signed)spc!=(sb | (sg<<8) | (sr<<16))){
										*pOut2 =  (db+sb)>>1;++pOut2;
										*pOut2 =  (dg+sg)>>1;++pOut2;
										*pOut2 =  (dr+sr)>>1;++pOut2;
									}

								}
							}
						}else{
							//32bit
							width1=ddsd.lPitch/4;
							width2=ddsd2.lPitch/4;
							unsigned int *pOut = (unsigned int *)ddsd.lpSurface;
							unsigned int *pIn = (unsigned int *)ddsd2.lpSurface;

							int spc=SpriteColor[page];
							for(int dy=0;dy<h;++dy){
								int ad_d=x+(dy+y)*width1;
								int ad_s=src_x+(dy+src_y)*width2;
								unsigned int *pOut = (unsigned int *)ddsd.lpSurface;
								unsigned int *pIn = (unsigned int *)ddsd2.lpSurface;
								pOut+= ad_d;
								pIn += ad_s;
								for(int dx=0;dx<w ;dx+=1){
									unsigned int d=*pOut;
									unsigned int s=*pIn & 0xffffff;
									if((unsigned)spc!=s){
										*pOut =  ((d>>1)&0x7f7f7f) + ((s>>1)&0x7f7f7f);
									}
									pOut++;
									pIn++;
								}
							}
							/*
							width1=ddsd.lPitch;
							width2=ddsd2.lPitch;
							unsigned char *pOut = (unsigned char *)ddsd.lpSurface;
							unsigned char *pIn = (unsigned char *)ddsd2.lpSurface;

							for(int dy=0;dy<h;++dy){
								int ad_d=x*4+(dy+y)*width1;
								int ad_s=src_x*4+(dy+src_y)*width2;
								for(int dx=0;dx<w*4 ;dx+=4){
									unsigned char dr=pOut[dx+ad_d];
									unsigned char dg=pOut[dx+ad_d+1];
									unsigned char db=pOut[dx+ad_d+2];
									unsigned char sr=pIn[dx+ad_s];
									unsigned char sg=pIn[dx+ad_s+1];
									unsigned char sb=pIn[dx+ad_s+2];
									if((signed)SpriteColor[page]!=(sr | (sg<<8) | (sb<<16))){
										pOut[dx+ad_d] =  (dr>>1) + (sr>>1);
										pOut[dx+ad_d+1] =  (dg>>1) + (sg>>1);
										pOut[dx+ad_d+2] =  (db>>1) + (sb>>1);
									}
								}
							}*/
						}
					}
					break;
			}
			g_pSprite[page]->Unlock(&rect2);
		}
		g_pDDSBack->Unlock(&rect);
					//	if(check==0 && width1!=width2){
					//		check=1;
					//		char moji[256];
					//		wsprintf(moji,"w1=%d w2=%d\n",width1,width2);
					//		OutputDebugString(moji);
					//	}
		z=z;//
	}
}
void XDraw::PutSpriteChip2(int x,int y,int w,int h,int src_x,int src_y,int page,int zoomx,int zoomy,int hflag)
{
	if(IsWindow(XDraw_hWnd)==0)
		return;
	if(page<0 || page>=SpriteMaxPage)
		return;
	RECT dr,sr;
	dr.left=x;
	dr.top=y;
	dr.right=x+w;
	dr.bottom=y+h;
	sr.left=src_x;
	sr.top=src_y;
	if(zoomx!=0 || zoomy!=0){
		sr.right=src_x+w;
		sr.bottom=src_y+h;
		dr.right=x+zoomx;
		dr.bottom=y+zoomy;
		if(dr.right>DisplayWidth){
			sr.right=src_x + w - (dr.right-DisplayWidth)/2;
			dr.right=DisplayWidth;
		}else{
			if(dr.left<0){
				sr.left=src_x -(dr.left/2);
				dr.left=0;
			}
		}
		if(dr.bottom>DisplayHeight){
			sr.bottom=src_y + h - (dr.bottom-DisplayHeight)/2;
			dr.bottom=DisplayHeight;
		}else{
			if(dr.top<0){
				sr.top= src_y -(dr.top/2);
				dr.top=0;
			}
		}
	}else{
		sr.right=src_x+w;
		sr.bottom=src_y+h;
		if(dr.right>DisplayWidth){
			sr.right=src_x + w - (dr.right-DisplayWidth);
			dr.right=DisplayWidth;
		}else{
			if(dr.left<0){
				sr.left=src_x -(dr.left);
				dr.left=0;
			}
		}
		if(dr.bottom>DisplayHeight){
			sr.bottom=src_y + h - (dr.bottom-DisplayHeight);
			dr.bottom=DisplayHeight;
		}else{
			if(dr.top<0){
				sr.top= src_y -(dr.top);
				dr.top=0;
			}
		}
	}
	if(hflag==0){
		if(zoomx!=0 || zoomy!=0){
			g_pDDSBack->Blt(&dr, g_pSprite[page],  &sr, DDBLT_WAIT ,  NULL);
			g_pBG->Blt(&dr, g_pSprite[page],  &sr, DDBLT_WAIT ,  NULL);
		}else{
			g_pDDSBack->BltFast(dr.left,dr.top, g_pSprite[page],  &sr, DDBLTFAST_WAIT);// 
			g_pBG->BltFast(dr.left,dr.top, g_pSprite[page],  &sr, DDBLTFAST_WAIT);// 
		}
	}else{
		if(zoomx!=0 || zoomy!=0){
			g_pDDSBack->Blt(&dr, g_pSprite[page],  &sr, DDBLT_WAIT  | DDBLT_KEYSRC,  NULL);
			g_pBG->Blt(&dr, g_pSprite[page],  &sr, DDBLT_WAIT  | DDBLT_KEYSRC,  NULL);
		}else{
			g_pDDSBack->BltFast(dr.left,dr.top, g_pSprite[page],  &sr, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);// 
			g_pBG->BltFast(dr.left,dr.top, g_pSprite[page],  &sr, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);// 
		}
	}
//	g_pBG->BltFast(x,y, g_pBGSurface,  &sr, DDBLTFAST_WAIT);// 
	return;

}

//g_pBG

/*
void XSprite::BitmapReDraw(int page)
{
	//炠HBITMAPT[tFXɓ]iĕ`j
	//ڂcha𑀍삵̍XVɎgĂB
	HDC DC=GetDC(NULL);
	HDC hMemDC=CreateCompatibleDC(DC);
	HBITMAP hBmpOld;

	HDC hDC;
	if(page==-1){//wiʂɒڏ
		BITMAP bmp;
		GetObject(KeepBGBmp,sizeof(BITMAP),&bmp);
		hBmpOld=(HBITMAP)SelectObject(hMemDC,KeepBGBmp);
		if(pBGSurface->GetDC(&hDC) == DD_OK) {
			BitBlt(hDC,0,0,Screen_Width,Screen_Height,hMemDC,0,0,SRCCOPY);
			pBGSurface->ReleaseDC(hDC);
		}
	}else{//XvCgp^[ʂɏ
		if(page){
			hBmpOld=(HBITMAP)SelectObject(hMemDC,KeepBmp[page]);
			if(pSpriteData[page]->GetDC(&hDC) == DD_OK) {
				BitBlt(hDC,0,0,Screen_Width,Screen_Height,hMemDC,0,0,SRCCOPY);
				pSpriteData[page]->ReleaseDC(hDC);
			}
		}
	}
	SelectObject(hMemDC,hBmpOld);
	DeleteDC(hMemDC);
	ReleaseDC(NULL,DC);
}
int XSprite::GetSurface(int page1, int page2)
{
	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC));
	ZeroMemory(&ddsd2, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
	ddsd2.dwSize = sizeof(ddsd2);
	switch(page1){
		case 0:
			if(pBGSurface->Lock(NULL, &ddsd, NULL, NULL) != DD_OK)
				return FALSE;
		break;
		case 1:
		case 2:
		case 3:
			if(pSpriteData[page1]->Lock(NULL, &ddsd, NULL, NULL) != DD_OK) 
				return FALSE;
		break;
	}
	lpPixel = lpPixel2 = (short int *)ddsd.lpSurface;
	if(page1!=page2){
		switch(page2){
			case 0:
				if(pBGSurface->Lock(NULL, &ddsd2, NULL, NULL) != DD_OK)
					return FALSE;
			break;
			case 1:
			case 2:
			case 3:
				if(pSpriteData[page2]->Lock(NULL, &ddsd2, NULL, NULL) != DD_OK) 
					return FALSE;
			break;
		}
		lpPixel2 = (short int *)ddsd2.lpSurface;
	}

	return TRUE;
}

void XSprite::DeleteSurface(int page1, int page2)
{
	if(page1!=page2){
		switch(page2){
			case 0:
				pBGSurface->Unlock(ddsd2.lpSurface);
			break;
			case 1:
			case 2:
			case 3:
				pSpriteData[page2]->Unlock(ddsd2.lpSurface); 
			break;
		}
	}
	switch(page1){
		case 0:
			pBGSurface->Unlock(ddsd.lpSurface);
		break;
		case 1:
		case 2:
		case 3:
			pSpriteData[page1]->Unlock(ddsd.lpSurface); 
		break;
	}

}
 
*/

void XDraw::UpdateBuffer(LPDIRECTDRAWSURFACE7 pDDSBack)
{//_~[

}

void XDraw::UseSprite(int flag)
{
	UseSpriteFlag=flag;
}

void XDraw::SetSpriteColor(int page,int c)
{
	SetMaskColor(page,c);
}
void XDraw::SetMaskColor(int page,int c){//F̎w
	if(page<DefaultSpriteMaxPage){
		SpriteColor[page]=c;
		DDCOLORKEY ddckey;
		ddckey.dwColorSpaceLowValue = DDColorMatch(g_pSprite[page], SpriteColor[page] );
		ddckey.dwColorSpaceHighValue = DDColorMatch(g_pSprite[page], SpriteColor[page] );
		g_pSprite[page]->SetColorKey(DDCKEY_SRCBLT,&ddckey);
	}
};

void XDraw::AlphaBlt()
{
	if(DisplayColor<16 || AlphaDepth==256)
		return;
	int x,y,r,g,b;
	RECT rect={0};
	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
		HDC hDC;
		short int cc;
		if(g_pDDSBack->GetDC(&hDC) == DD_OK) {
			HDC dc=GetDC(NULL);
			HDC hMemDC=CreateCompatibleDC(dc);
			HBITMAP hBmpOld=(HBITMAP)SelectObject(hMemDC,TempBmp);
			BitBlt(hMemDC,0,0,DisplayWidth,DisplayHeight,hDC,0,0,SRCCOPY);
		//	BitBlt(dc,0,0,DisplayWidth,DisplayHeight,hMemDC,0,0,SRCCOPY);
			int c2=GetPixel(hMemDC,0,0);
			SetPixelV(hMemDC,0,0,RGB(255,255,255));
			cc=*((short int*)pTemp);
			SetPixelV(hMemDC,0,0,c2);
			SelectObject(hMemDC,hBmpOld);
			DeleteDC(hMemDC);
			ReleaseDC(NULL,dc);
			g_pDDSBack->ReleaseDC(hDC);
		}
	if(DisplayColor==16){
		if(SurfaceColorBit==15){
			//15rbg@5,5,5
			/*
			if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
				int width=ddsd.lPitch/2;
				unsigned short int *pOut = (unsigned short int *)ddsd.lpSurface;
				for(y=0;y<DisplayHeight;++y){
					for(x=0;x<DisplayWidth;++x){
						int ad=x+y*width;
						int c=pOut[ad];
						r=(((c>>10)&31)*AlphaDepth)>>8;
						g=(((c>>5 )&31)*AlphaDepth)>>8;
						b=(( c     &31)*AlphaDepth)>>8;
						pOut[ad]=(r<<10) | (g<<5) | b;
						//dib[x+y*Display_Width]=(dib[x+y*Display_Width]>>1) & 0x3def;//011 1101 1110 1111
					}
				}
				g_pDDSBack->Unlock(&rect);
			}
			*/
			if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
				int width=ddsd.lPitch/2;
				for(y=0;y<DisplayHeight;++y){
					unsigned short int *pOut = (unsigned short int *)ddsd.lpSurface;
					unsigned short int *pIn = (unsigned short int *)pTemp;
					pOut +=y*width;
					pIn +=y*width;
					for(x=0;x<DisplayWidth;++x){
						int c=*pIn;
						r=(((c>>10)&31)*AlphaDepth)>>8;
						g=(((c>>5 )&31)*AlphaDepth)>>8;
						b=(( c     &31)*AlphaDepth)>>8;
						*pOut=(r<<10) | (g<<5) | b;
						++pOut;
						++pIn;
					}
				}
				g_pDDSBack->Unlock(&rect);
			}
		}else{
			//16rbg 5,6,5
			/*
			if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
				int width=ddsd.lPitch/2;
				for(y=0;y<DisplayHeight;++y){
					unsigned short int *pOut = (unsigned short int *)ddsd.lpSurface;
					for(x=0;x<DisplayWidth;++x){
						int ad=x+y*width;
						int c=pOut[ad];
						r=(((c>>11)&31)*AlphaDepth)>>8;
						g=(((c>>5 )&63)*AlphaDepth)>>8;
						b=(( c     &31)*AlphaDepth)>>8;
						pOut[ad]=(r<<11) | (g<<5) | b;
						//dib[x+y*Display_Width]=(dib[x+y*Display_Width]>>1) & 0x3def;//011 1101 1110 1111
					}
				}
				g_pDDSBack->Unlock(&rect);
			}
			*/
			if(cc==0x7fff){
				if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
					int width=ddsd.lPitch/2;
					for(y=0;y<DisplayHeight;++y){
						unsigned short int *pOut = (unsigned short int *)ddsd.lpSurface;
						unsigned short int *pIn = (unsigned short int *)pTemp;
						pOut +=y*width;
						pIn +=y*width;
						for(x=0;x<DisplayWidth;++x){
							int c=*pIn;
							r=(((c>>10)&31)*AlphaDepth)>>8;
							g=(((c>>5 )&31)*AlphaDepth)>>8;
							b=(( c     &31)*AlphaDepth)>>8;
							*pOut=(r<<11) | (g<<6) | b;
							++pOut;
							++pIn;
						}
					}
					g_pDDSBack->Unlock(&rect);
				}
			}else{
				if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
					int width=ddsd.lPitch/2;
					for(y=0;y<DisplayHeight;++y){
						unsigned short int *pOut = (unsigned short int *)ddsd.lpSurface;
						unsigned short int *pIn = (unsigned short int *)pTemp;
						pOut +=y*width;
						pIn +=y*width;
						for(x=0;x<DisplayWidth;++x){
							int c=*pIn;
							r=(((c>>11)&31)*AlphaDepth)>>8;
							g=(((c>>5 )&63)*AlphaDepth)>>8;
							b=(( c     &31)*AlphaDepth)>>8;
							*pOut=(r<<11) | (g<<5) | b;
							++pOut;
							++pIn;
						}
					}
					g_pDDSBack->Unlock(&rect);
				}
			}
		}
	}else{
		/*if(DisplayColor==24){
			//24rbg
			if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
				int width=ddsd.lPitch/3;
				for(y=0;y<DisplayHeight;++y){
					unsigned char *pOut = (unsigned char*)ddsd.lpSurface;
					pOut+=y*width*3;
					for(x=0;x<DisplayWidth;++x){
//						*pOut=(unsigned char)((*pOut*AlphaDepth)>>8);
//						++pOut;
//						*pOut=(unsigned char)((*pOut*AlphaDepth)>>8);
//						++pOut;
//						*pOut=(unsigned char)((*pOut*AlphaDepth)>>8);
//						++pOut;
						int ad=x*3;
						r=(pOut[ad+2]*AlphaDepth)>>8;
						g=(pOut[ad+1]*AlphaDepth)>>8;
						b=(pOut[ad+0]*AlphaDepth)>>8;
						pOut[ad+0]=b;
						pOut[ad+1]=g;
						pOut[ad+2]=r;
					}
				}
				g_pDDSBack->Unlock(&rect);
			}
		}*/
		if(DisplayColor==24){
			//24rbg
			if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
				int width=ddsd.lPitch/3;
				for(y=0;y<DisplayHeight;++y){
					int w=width*3/4;
					unsigned int *pOut = (unsigned int*)ddsd.lpSurface;
					unsigned int *pIn = (unsigned int*)pTemp;
					pOut+=y*w;
					pIn+=y*w;
					for(x=0;x<w;++x){
						unsigned int c=*pIn;
						int c1=((c&255)*AlphaDepth)>>8;
						int c2=(((c>>8)&255)*AlphaDepth)>>8;
						int c3=(((c>>16)&255)*AlphaDepth)>>8;
						int c4=(((c>>24)&255)*AlphaDepth)>>8;
						*pOut=c1 | (c2<<8) | (c3<<16) | (c4<<24);
						++pOut;
						++pIn;
					}
				}
				g_pDDSBack->Unlock(&rect);
			}
		}
		if(DisplayColor==32){
			//32
			if(g_pDDSBack->Lock(&rect, &ddsd, DDLOCK_WAIT, NULL) == DD_OK) {
				int width=ddsd.lPitch/4;
				for(y=0;y<DisplayHeight;++y){
					unsigned int *pOut = (unsigned int*)ddsd.lpSurface;
					unsigned int *pIn = (unsigned int*)pTemp;
					pOut+=y*width;
					pIn+=y*width;
					for(x=0;x<width;++x){
						unsigned int c=*pIn;
						int c1=((c&255)*AlphaDepth)>>8;
						int c2=(((c>>8)&255)*AlphaDepth)>>8;
						int c3=(((c>>16)&255)*AlphaDepth)>>8;
						int c4=(((c>>24)&255)*AlphaDepth)>>8;
						*pOut=c1 | (c2<<8) | (c3<<16) | (c4<<24);
						++pOut;
						++pIn;
					}
				}
				g_pDDSBack->Unlock(&rect);
			}
		}
	}
}
/*
						width1=ddsd.lPitch/2;
						width2=ddsd2.lPitch/2;
						unsigned short int *pOut = (unsigned short int *)ddsd.lpSurface;
						unsigned short int *pIn = (unsigned short int *)ddsd2.lpSurface;

						for(int dy=0;dy<h;++dy){
							int ad_d=x+(dy+y)*width1;
							int ad_s=src_x+(dy+src_y)*width2;
							for(int dx=0;dx<w ;++dx){
								unsigned short int c = pIn[dx+ad_s];
								if(sp_color!=c){
									c = (c>>1)& 0x3def;
									unsigned short int d = (pOut[dx+ad_d]>>1)& 0x3def;
									pOut[dx+ad_d] =  c;
								}
							}

*/